/*
#$Id: kxyTable.js,v 1.1.2.1 2009/07/17 05:47:53 dcc Exp $#
######################################################################
# Copyright 1999-2003, Candle Corporation, a California corporation.  
# All rights reserved. International copyright secured.
#
# This material is proprietary to Candle Corporation and is not to be
# reproduced, used, or disclosed except in accordance with program
# licenses or upon written authorization of Candle Corporation.
#
#######################################################################*/
/**********************************************************************************************
					Table.js
***********************************************************************************************
Table.js has functions that help in creating the table in the Message Window that displays the 
messages for a Queue 
***********************************************************************************************
***********************************************************************************************/



/**********************************************************************************************
Variables --
tagHeading	: is an array to carry the tag names inside the header of the body of a message.
tagValue	: is an array to carry values for the tags in header of the body of a message.
tagHeadingBody	: is an array to carry the tag names inside the body of the body of a message.
tagValueBody	: is an array to carry values for the tags in body of the body of a message.
widthScreen	: is the value of the width of the table which if exceeded by a message will 
		cause the table to have horizontal scroll bars..
param		: is an array that will carry the values of the tags of the body of a message 
		in order to be passed to the modal window that edits the body of the XML of message.
conID		: will carry the value of the tag with name 'connid' that is connection id.

***********************************************************************************************/

var bodyNode;
var kxy_type;
var temptag;
var conID;
var pathM,messagesM,currentIndexM,maxM;
var selectedConID;
var selectedMessage;
var beginSequence = 0;
var endSequence = 0;
var messageDepth = 0;
var disableFirst = 0;
var disableNext = 0;
var disableLast = 0;
var disablePrevious = 0;
var win;
var DocumentToPrint;
var mesLength = 0;
var sendType;
var selectedFmt = "";
var selectedpFmt="";

var findReplFlag = 1;
var XMLEncodingVal = "";

var bgN = "bg10";
var bgR = "bg_red";
var bgG = "bg9";

var indexMsg = 0;

var CachedImage = new Image;
CachedImage = "images/msg_menu.gif";


var tempI = 0;

var mesRow;
var mesRow0;
var mesRowH;

function showTable()
{
do
{
	tab2.appendChild(mesRow[tempI]);
	tab0.appendChild(mesRow0[tempI]);
	tempI++;
}
while(tempI != mesLength);

}


var tab2;
var tab0;
var tab3;
/**********************************************************************************************
The function generateTable is called by Manager in order to display the table with messages for
a Queue. It takes following argument:
response	: is the XML DOM object for the XML that carries the details of the messages in
		a Queue.
header		: is true if user has chechked the checkbox in the 'Open Queue' dilog window 
		that says 'Display Headers for Messages'.		
***********************************************************************************************/
function generateTable(response,headerXML, indexBegin, indexEnd)
{
	var theDoc = document;
	countSelectedM = 0;
	mesLength = count("//Response/Body/Message",response);
	if(indexBegin == null && indexEnd == null || (indexBegin != null && indexBegin == 0))
	{
		var newT = theDoc.getElementById('divBM');
		tab2 = theDoc.createElement("pre");
		newT.appendChild(tab2);
	}
	else
		tab2 = theDoc.getElementById('divBM').firstChild;

	if (mesLength > 0 )
	{
		if(indexBegin == null)
			var indexB = 0;
		else
			var indexB = indexBegin;

		if(indexEnd == null)
			var indexE = mesLength;
		else
			var indexE = indexEnd;

	mesRow = new Array();
	mesRow0 = new Array();
	
	tab0 = theDoc.getElementById('menuM');
	var oPrivateTree = theDoc.createElement("TABLE");
	var oMasterRow = theDoc.createElement("TR");
	oPrivateTree.appendChild(theDoc.createElement("TBODY"));
	oPrivateTree.firstChild.appendChild(oMasterRow);

	var oPrivateTree1 = oPrivateTree.cloneNode(true);
	
	var oMasterRow1 = theDoc.createElement("TR");
	oPrivateTree.firstChild.appendChild(oMasterRow1);
	
	var newTDCell = theDoc.createElement("TD");
	newTDCell.appendChild(theDoc.createTextNode(" ") );
	var newTDCell2 = newTDCell.cloneNode(true);
		
	newTDCell.className = 'bgTable';

	var newTDCell1 = theDoc.createElement("TD");
	newTDCell1.className = 'bgHeader';
	newTDCell1.appendChild(theDoc.createTextNode(" ") );
	
	newTDCell2.appendChild(theDoc.createElement("br"));
	var newImg = theDoc.createElement("img");
	newImg.src=CachedImage;
	
	newTDCell2.appendChild(newImg);
				
	var newC1 = theDoc.createElement("input");
	newC1.type='checkbox';
	newTDCell2.appendChild(newC1);
			
	oPrivateTree1.firstChild.firstChild.appendChild(newTDCell2);

	var iteration = indexE - indexB;
	
	
	//////////////////////////////////////////////////////////////////////////////////////////////////////
	for(var messages = indexB; messages < indexE; messages++)
	{
		var mnode = getXMLTag("/Response/Body/Message["+messages+"]",current_peek).cloneNode("true");
		bodyNode = getXMLTag("Body",mnode);
		conID =  getTag("//ConnId",mnode);
		var bodyTypeJMS = getTag("//BodyType",mnode);

		var fmt = getTag("//format",mnode);
		var pFmt = getTag("//pFormat",mnode);

		if(QType != TYPEMQ && (bodyTypeJMS == "Stream" || bodyTypeJMS == "Map"))
			temptag = bodyTypeJMS;
		else
		{
			temptag = pFmt;
			if(rtrim(ltrim(pFmt)).length == 0)
				temptag = fmt;	
		}
		kxy_type = getTag("//KXY_TYPE",mnode);
		var kxyStatus = getTag("//KXY_STATUS",mnode);
		var STATUS = getTag("//STATUS",mnode);
		var mes_seq_no = getTag("//MessageSequenceNumber",mnode);

		var new14 = oPrivateTree1.cloneNode(true);
		new14.id='TABLE_14_'+messages;

		var new15 = new14.firstChild.firstChild;

		var new4 = oPrivateTree.cloneNode(true);
		new4.id='TABLE_4_'+messages;

		var new7 = new4.firstChild.firstChild;
		var new5 = new4.firstChild.lastChild;
		new7.id='TR1_'+conID;
		new5.id='TR2_'+conID;

		var fmt_name="";
		if(temptag != null)
		for(var k=temptag.length;k>=1;k--){
			if(temptag.charAt(k) == ":")
			{
				fmt_name = temptag.substring(k+1,temptag.length);
				break;
			}
		}

		if(fmt_name != "")
			temptag = fmt_name;

		if(bodyNode != null)
		{
			var newTD = new15.firstChild;
			newTD.id='TR'+messages;
			newTD.value=conID;
			newTD.kxyType=kxy_type;
			newTD.format=temptag;
			newTD.fmt=fmt;
			newTD.pFmt=pFmt;

			var parse_error = 0;

			var partial = getTag("//Partial",mnode);

			if(partial == "Yes")
			{
				newTD.className=bgR;	
				if(kxyStatus == "MDR_PARSE_ERROR")
					newTD.firstChild.nodeValue = "*!";
				else
					newTD.firstChild.nodeValue = "* ";
				parse_error = 1;	
			}
			else
			{
				if(kxyStatus == "MDR_PARSE_ERROR")
				{
					newTD.className=bgR;	
					newTD.firstChild.nodeValue = "! ";
					parse_error = 1;
				}
				else
					newTD.className=bgN;	
			}

			if(STATUS != "")
			{
				newTD.className=bgR;	
				var tempV = newTD.firstChild.nodeValue;
				newTD.firstChild.nodeValue = tempV + STATUS;
				parse_error = 1;
			}
			else
			{
				var tempV = newTD.firstChild.nodeValue;
				newTD.firstChild.nodeValue = tempV + " " + mes_seq_no;
			}
			
			var newTD1 = newTD.childNodes[2];
			newTD1.id= 'imgMsg'+conID;
			newTD1.mNo=messages;
			newTD1.onmouseout=hideMenuMsg;
			newTD1.onmousedown=onMouseDownHandler;

			var newTD2 = newTD.childNodes[3];
			newTD2.onclick=highlightRow;
			newTD2.id='checkbox'+messages;
			newTD2.mNo=messages;
			newTD2.err=parse_error;
			
			messagesM = messages;
			
			if(kxy_type == "RAW_TEXT" || kxy_type == "RAW_HEXA")
			{
				indexMsg = 0;
				var node_Child = bodyNode.childNodes;
				var len = node_Child.length

				if(len < 21)
					var count1 = len;
				else
					var count1 = 21;
					
				var temp1 = "tdHeadB"+ messages +"_";
				var temp2 = "div_"+conID+"_";
				 for(var p=0; p < count1; p++)
				 {
					if(indexMsg == 20)
					{
						currentIndex = indexMsg;
						displaySymbol(0,new5);
						indexMsg++;
						break;
					}

					if(indexMsg == 100)
						break;
					indexMsg = indexMsg + 1;
					
					var new8 = newTDCell.cloneNode(true);
					var node_name = node_Child[p].nodeName;
					new8.onclick=selectColumnF;
					new8.id= temp1 + indexMsg+"_"+node_name;
					new8.firstChild.nodeValue = node_name;
					
					var new6 = newTDCell1.cloneNode(true);
					new6.id = temp2+indexMsg;
					new6.onclick=captureEvent;
					if(node_Child[p].firstChild != null)
						new6.firstChild.nodeValue = node_Child[p].firstChild.nodeValue;
					
					new7.appendChild(new8);
					new5.appendChild(new6);	
				}
			}
			else
			{
				indexMsg = 0;
				pathM = "";
				currentIndexM = 0;
				maxM = 20;
				getMessageBody(new7,new5,newTDCell,newTDCell1);
			}
			mesRow0[messages] = new14;	
			mesRow[messages] = new4;
			
			if(indexBegin != null || indexEnd != null)
			{
				var newTH = theDoc.getElementById('divHM');
				if (headerXML == "true" || (headerXML == "false" && newTH.innerHTML != ""))
				{
					if(newTH.innerHTML == "")
					{
						var tab3 = theDoc.createElement("pre");
						newTH.appendChild(tab3);
					}
					else
						tab3 = newTH.firstChild;

					var new3_4 = theDoc.createElement("table");
					var new3_7 = new3_4.insertRow();
					var new3_5 = new3_4.insertRow();

					new3_7.id =  "TRH1_"+messages;
					new3_5.id =  "TRH2_"+messages;
					showHeaders(true, messages, mnode, conID,new3_5,new3_7);

					tab3.appendChild(new3_4);

					if(headerXML == "true")
						theDoc.getElementById('divBM').style.left = "-10";

				}
			}
		}
	}
	
	tempI = indexB;
	setTimeout("showTable()",1);	

	beginSequence = getTag("/Response/Body/Message[0]//MessageSequenceNumber",response);
	var IELength = mesLength-1;
	endSequence = getTag("/Response/Body/Message["+IELength+"]//MessageSequenceNumber",response);
	messageDepth = getTag("/Response/Header/QueueDepth",response);
	if(indexBegin == null && indexEnd == null)
	{
		var newTH = theDoc.getElementById('divHM');
		if (headerXML == "true" || (headerXML == "false" && newTH.innerHTML != ""))
			showHeaders(true);
	}

}
else{

	loadingMessage("<center>There are no messages in the queue or no more messages meeting the filter criteria.</center>");
	document.getElementById('seqNumber').style.display = 'none';
	document.body.style.cursor="default";
	disableFirst = 0;
	disableLast = 0;
}

}



//////////////////////////////////////////////////////////////////////////////////////////



function tableStatus()
{
if (mesLength > 0 )
{
	var htmlSeqNo = "<font class='dark'><b>Messages:  </b></font><font class='messageCounter'>"+beginSequence+" to "+endSequence;
	htmlSeqNo += " of "+messageDepth;
	htmlSeqNo += "</font>";
	var seqID = document.getElementById('seqNumber');
	seqID.innerHTML = htmlSeqNo;
	seqID.style.display="block";
	document.getElementById('selectAllCheckBoxes').innerHTML = "<input type ='checkbox' id='checkAll' onClick='selectAll(this)'> <font class='ListHeader'> Select All Messages</font>";
	
	document.getElementById('dispHeader').style.display = "block";

	var tempLen = mesLength * 54;

	if(tempLen < heightScreen-5)
		document.getElementById('divM').style.height = heightScreen - 10;
	else
		document.getElementById('divM').style.height = tempLen;
		

	handleNavigation();
	
	var checkID = document.getElementById('checkAll');
	checkID.checked = false;
	checkID.focus();
}
if(displayHeader == "true")
 	document.getElementById('showHeader').checked = true;
}


function showHeaderTable()
{
tempI = 0
do
{
	tab3.appendChild(mesRowH[tempI]);
	tempI++;
}
while(tempI != mesLength);
}



function showHeaders(oCheckbox, messages, mnode, con_ID, headDIV, headBDIV)
{
	if(messages != null)
	{
		var theDoc = document;
		var newTDCell1 = theDoc.createElement("TD");
		newTDCell1.appendChild(theDoc.createTextNode(" ") );
		var newTDCell2 = newTDCell1.cloneNode(true);
		newTDCell1.className = 'bgHeader';
		newTDCell2.className = 'bgTable';
			
       		messagesM = messages;
       		bodyNode = getXMLTag("//Header",mnode).cloneNode("true");
		generateHeaders(headDIV, headBDIV,newTDCell1,newTDCell2);
	}
	else
	{
	    var newTH = document.getElementById('divHM');
	    if(oCheckbox || oCheckbox == null)
	    {
	    	if(newTH.style.display == "none" && newTH.innerHTML != "")
	    	{
	    		newTH.style.display = "block";
	    	}
	    	else
	    	{
	    		var theDoc = document;
			var oPrivateTree = theDoc.createElement("TABLE");
			var oMasterRow = theDoc.createElement("TR");
			oPrivateTree.appendChild(theDoc.createElement("TBODY"));
			oPrivateTree.firstChild.appendChild(oMasterRow);

			var oMasterRow1 = theDoc.createElement("TR");
			oPrivateTree.firstChild.appendChild(oMasterRow1);

			var newTDCell1 = theDoc.createElement("TD");
			newTDCell1.appendChild(theDoc.createTextNode(" ") );
			var newTDCell2 = newTDCell1.cloneNode(true);
			newTDCell1.className = 'bgHeader';
			newTDCell2.className = 'bgTable';

	    		tab3 = document.createElement("pre");
			newTH.appendChild(tab3);
			mesRowH = new Array();

			for(var messages = 0; messages < mesLength; messages++)
			{
				var mnode = getXMLTag("/Response/Body/Message["+messages+"]/Header",current_peek).cloneNode("true");
				conID =  getTag("//ConnId",mnode);

				var new3_4 = oPrivateTree.cloneNode(true);
				var tempT = new3_4.firstChild;
				var new3_7 = tempT.firstChild;
       				var new3_5 = tempT.childNodes[1];
       				new3_7.id =  "TRH1_"+messages;
       				new3_5.id =  "TRH2_"+messages;
       				messagesM = messages;
       				bodyNode = mnode;
				generateHeaders(new3_5, new3_7,newTDCell1,newTDCell2);	
				mesRowH[messages] = new3_4;
			}
			setTimeout("showHeaderTable()",1);
		}
		displayHeader = "true";
		defaultHeader = "true";
		newTH.style.display = "block";
		document.getElementById('divBM').style.left = '-10';
		
	    }
	    else
	    {
		newTH.style.display = "none";
		displayHeader = "false";
		defaultHeader = "false";
		document.getElementById('divBM').style.left = '0';
	    }
	}
	
}



function generateHeaders(new12, new15,newTDCell1,newTDCell2)
{
	var mnode = bodyNode;
	var temp1 = "tdHeadH"+messagesM+"_";
	var temp2 = "div_"+conID+"_";

	var countHeader = count("/MD/*",mnode);

	for(var i = 0; i < countHeader;i++)
	{
		var aux=getXMLTag("/MD/*["+i+"]",mnode);

		var node_name = aux.nodeName;
		var new9 = newTDCell1.cloneNode(true);
		new9.id = temp1+node_name;
		new9.onclick = selectColumnH;
		new9.firstChild.nodeValue = node_name;

		var new10 = newTDCell2.cloneNode(true);
		new10.id = temp2+node_name;

		new10.onclick = captureEvent;
		if(node_name == "putApplicationName")
			new9.width='350';
		if(aux.firstChild != null)
			new10.firstChild.nodeValue = aux.firstChild.nodeValue;

		new15.appendChild(new9);
		new12.appendChild(new10);			
	}
}


function selectColumnH()
{
	var id = this.getAttribute('id');
	var name =id.substr(id.indexOf("_")+1,id.length);
	var type="Header";
	highlightColH(id, name,type);
}

function highlightColH(id, name,type)
{
if (colSelected == 0)
{
	t_colId = id;
	t_colName = name;
	t_kxyType = type;
	for(var q = 0; q < mesLength; q++)
	{
		var col = document.getElementById("tdHeadH"+q+"_"+t_colName);
		if(col != null)
		{
			if(document.getElementById('checkbox' + q) != null)
				col.className = COLORHEADERON;
			else
				col.className = COLORHEADEROFFHEAD;
		}
	}
	selectedColumn=t_colId;
	colSelected=1;
}else
{
	if(t_kxyType != "Header")
	{
		selectCol(t_colName,t_colId,t_format,t_kxyType,t_index,t_column);
		highlightColH(id, name,type);
	}
	else
	{
		if(id != null && id == t_colId)
		{
 			for(var q = 0; q < mesLength; q++)
 			{
 				var col = document.getElementById("tdHeadH"+q+"_"+t_colName);
				if(col != null)
 					col.className = COLORHEADEROFFHEAD;
			}
			colSelected=0;
			selectedColumn = null;
 		}
		else
		{
 			for(var q = 0; q < mesLength; q++)
 			{
 				var col = document.getElementById("tdHeadH"+q+"_"+t_colName);
				if(col != null)
 					col.className = COLORHEADEROFFHEAD;
			}
			t_colId = null;
			t_colName = null;
			t_kxyType = null;
			colSelected=0;
			selectedColumn = null;
			if(id != null )
				if(type == "Header")
					highlightColH(id, name,type);
		}	
	}
}
}


function handleNavigation()
{
if(endSequence == messageDepth){
	disableNext = 1;
	disableLast = 1;
}
else{
	disableNext = 0;
	disableLast = 0;
}
if(beginSequence == 1 || beginSequence == 0){
	disablePrevious = 1;
	disableFirst = 1;
}
else{
	disablePrevious = 0;
	disableFirst = 0;
}
}

var currentI;


function showSubMenu(e,id,message){

if(browser != "NS")
	var e = event;
    var x=y=0;
    if (e != '') {
        x = e.screenX;
        y = e.screenY;
    }
if(browser == "NS")
{
	x = x - self.screenX + 5;
	y = y - self.screenY - 20;
}
else
{
	x = x - self.screenLeft + 7;
	y = y - self.screenTop + 7;
}
var h = document.getElementById('messagesDisplay').style.height;
h = h.substring(0, h.length-2);


var commitMenu = 0;

if ((needcommit==true)&&(sync=='transactional'))
{
	var temp = getTag("/Response/Body/Message["+message+"]/Header/KXY/STATUS",current_peek);
	if (temp == "INS" || temp == "UPD")
		commitMenu = 1;
}
if(commitMenu == 1)
{
if( y > h)
	y = y - 40;
	showPopupMenu('tableT2',x,y,'',id,message);
}
else
{
if( y > h)
	y = y - 120;
	showPopupMenu('tableT',x,y,'',id,message);
}

}


function hideMenuMsg()
{
	hidePopupMenu('tableT');
}



function onMouseDownHandler(e) 
{
	var message = this.getAttribute('mNo');
	var id = document.getElementById('TR'+message).value;
	selectedMessage = message;
	if(browser != "NS")
	{
		var e = event;	
		if(e.button == 1)
		{
			var commitMenu = 0;

			if ((needcommit==true)&&(sync=='transactional'))
			{
				var temp = getTag("/Response/Body/Message["+message+"]/Header/KXY/STATUS",current_peek);
				if (temp == "INS" || temp == "UPD")
					commitMenu = 1;
			}
			if(commitMenu == 0)
			{
				if(!bufferFull)
				{
					hidePopupMenu('');
					M_edit([id],message);
				}
				else
					M_alert(err_273);
			}
		}
		else
		if(e.button == 2 || e.button == 3)
			showSubMenu(e,id,message);
		
	}
	if(browser == "NS" && (e.which==1 || e.which==3 || e.which==2))
	{
     		showSubMenu(e,id,message);
    	}
}


function hideColumn(message,q,type){

	if(type == 'header'){
		var imageHTML = "<img src='images/triclose.gif' name='image"+messages+q+"' onClick=showColumn('"+message+"','"+q+"','header') /></td>";
		eval("document.all.tdHead"+message+q+".innerHTML=imageHTML");
		eval("document.all.tdBody"+message+q+".innerHTML='<br/>'");
	}
	else
	{
		var imageHTML = "<img src='images/triclose.gif' name='imageB"+messages+q+"' onClick=showColumn('"+message+"','"+q+"','body') /></td>";
		eval("document.all.tdHeadB"+message+q+".innerHTML=imageHTML");
		eval("document.all.td"+message+q+".innerHTML='<br/>'");
	}
}


function showColumn(message,q,type){

getMessageValues(resp[1].childNodes[message],message);

if(type == 'header'){
	var tempHTML = "<td id='tdHead"+message+q+"'><font class='tableHeader'><b>"+tagHeading[q]+"</b></font>";
	tempHTML += "<img src='images/triopen.gif' name='image"+message+q+"' onClick=hideColumn('"+message+"','"+q+"','header') /></td>";
	eval("document.all.tdHead"+message+q+".innerHTML=tempHTML");
	tempHTML = "<td class='bg2' id='tdBody"+message+q+"'><font class='tableValue'><b>"+tagValue[q]+"</b></font></td>";
	eval("document.all.tdBody"+message+q+".innerHTML=tempHTML");
}
else
{
	var tempHTML = "<td id='tdHeadB"+message+q+"'><font class='tableValue'><b>"+tagHeadingBody[q]+"</b></font>";
	tempHTML += "<img src='images/triopen.gif' name='imageB"+message+q+"' onClick=hideColumn('"+message+"','"+q+"','body') /></td>";
	eval("document.all.tdHeadB"+message+q+".innerHTML=tempHTML");
	tempHTML = "<td class='bg2' id='td"+message+q+"'><font class='tableHeader'><b>"+tagValueBody[q]+"</b></font></td>";
	eval("document.all.td"+message+q+".innerHTML=tempHTML");
}
}

var not_EventCapture=true;

function highlight(cell,value,conID) {

if (not_EventCapture)
{
	selectedConID = conID;
	//selectedField = tempVal;
	selectedFieldTag = tagHeadingBody[value];
	//selectedPathForHex = temppath;

	
//set cross-browser DOM
      if (document.all) {
         docObj = eval("document.all." + cell + ".style");
         if(selectedCell != null && selectedCell != cell)
         	docOldObj = eval("document.all." + selectedCell + ".style");
      } else {
         docObj = eval("document." + cell);
         if(selectedCell != null && selectedCell != cell)
	         docOldObj = eval("document." + selectedCell);
      }
   //change highlight color
   
     if(selectedCell != null && selectedCell != cell)
    	 if(docOldObj.background == COLOR_ROW){
 
     		docOldObj.background = COLOR_VISITEDROW;
   	  }

   
     if(docObj.background == COLOR_ROW){
 
     	docObj.background = COLOR_VISITEDROW;
     }
     	else{

     	docObj.background = COLOR_ROW;
     }
     
     selectedCell = cell;
}else
	not_EventCapture=true;
   }



function highlightRow() {
	var message = this.getAttribute('mNo');
	var id = document.getElementById('TR'+message).value;
	goReturn(message,id);
}



function selectAll(oCheckbox) {
lastCheckbox = "";
shiftFlag = 0;
var el, bWhich = oCheckbox.checked, oForm = oCheckbox.form; 
var i = 0;
if(browser == "NS")
	i = 0;

if(bWhich == true){
	while (el = oForm[i++]) if (el.type == 'checkbox' && el.id != 'checkAll' && el.id != 'showHeader')
	{
		el.checked = bWhich; 
		el.parentNode.className = bgG;
	}
	countSelectedM = mesLength;
}
else{
	while (el = oForm[i++]) if (el.type == 'checkbox' && el.id != 'checkAll' && el.id != 'showHeader')
	{
		el.checked = bWhich; 
		var err_flag;
		if(browser == "NS")
			err_flag = el.getAttribute('err');
		else
			err_flag = el.err;
		if(err_flag == 0)
       			el.parentNode.className = bgN;
       		else
       			el.parentNode.className = bgR;
	}
       	countSelectedM = 0;
}
}


function handleXMLEncoding(status)
{
	if(editOrCrtFlag == 1 && document.getElementById('headerEditor2') != null)
	{
		document.getElementById('headerEditor2').style.display = status;
		document.getElementById('head2Table').style.display = status;
		
		if(document.getElementById('headerEditor') != null)
		if(status == "none" )
		{
			if(QType == TYPEMQ)
				document.getElementById('headerEditor').style.height = showHeight - 70;
			else
				document.getElementById('headerEditor').style.height = showHeight - 90;
		}
		else
		{
			document.getElementById('headerEditor').style.height = showHeight - 150;
			if(browser == "NS")
			{
				document.getElementById("headerEditor2").style.position="absolute";
				document.getElementById("headerEditor2").style.top=500;
				document.getElementById("headerEditor2").style.left= 25;
			}
		}
	}
}



function checkSelection()
{
if(kxyType != "STRING")
{
	var formID = document.XMLTreeForm;
	
	if(document.getElementById('hexdump').checked)
	{
		setCursorDialog(127);
	}
	else if(formID.raw_type[2].checked)
	{
		document.getElementById('XMLOption').style.display = "block";
		document.getElementById('textareaStatus').style.display = "none";
		if(rtrim(ltrim(returnXML)).length == 0)
		{
			formID.raw_type[0].disabled = false;
			formID.raw_type[1].disabled = false;
			if(QType != TYPEMQ && editOrCrtFlag == 1)
			{
				formID.raw_type[3].disabled = false;
				formID.raw_type[4].disabled = false;
			}
		}
		else
		{
			formID.raw_type[0].disabled = true;
			formID.raw_type[1].disabled = true;
			if(QType != TYPEMQ && editOrCrtFlag == 1)
			{
				formID.raw_type[3].disabled = true;
				formID.raw_type[4].disabled = true;
			}	
			document.getElementById('hexdump').disabled = true;
		}
		formID.optionXML[0].checked = true;
		if(!readOnly)
			formID.XMLEntry.readOnly = false;
		else
			formID.XMLEntry.readOnly = true;
		handleXMLEncoding("block");
	}
	else
	if(formID.raw_type[1].checked)
	{
		document.getElementById('XMLOption').style.display = "none";
		document.getElementById('textareaStatus').style.display = "none";
		formID.XMLEntry.readOnly = true;
		handleXMLEncoding("none");

		if(rtrim(ltrim(returnXML)).length != 0)
		{
			formID.raw_type[2].disabled = true;
			formID.raw_type[0].disabled = true;
			if(QType != TYPEMQ && editOrCrtFlag == 1)
			{
				formID.raw_type[3].disabled = true;
				formID.raw_type[4].disabled = true;
			}
		}
		else
		{
			formID.raw_type[2].disabled = false;
			formID.raw_type[0].disabled = false;	
			if(QType != TYPEMQ && editOrCrtFlag == 1)
			{
				formID.raw_type[3].disabled = false;
				formID.raw_type[4].disabled = false;
			}
		
		}
		setCursorDialog(94);
	}
	else
	if(formID.raw_type[0].checked)
	{
		formID.XMLEntry.readOnly = false;
		document.getElementById('XMLOption').style.display = "none";
		document.getElementById('textareaStatus').style.display = "block";

		if(rtrim(ltrim(returnXML)).length != 0)
		{
			formID.raw_type[2].disabled = true;
			if(QType != TYPEMQ && editOrCrtFlag == 1)
			{
				formID.raw_type[3].disabled = true;
				formID.raw_type[4].disabled = true;
			}
		}
		else
		{
			formID.raw_type[2].disabled = false;	
			if(QType != TYPEMQ && editOrCrtFlag == 1)
			{
				formID.raw_type[3].disabled = false;
				formID.raw_type[4].disabled = false;
			}
		}
		
		if(!readOnly)
			formID.XMLEntry.readOnly = false;
		else
			formID.XMLEntry.readOnly = true;
		handleXMLEncoding("none");	
	}
	else
	if(QType != TYPEMQ && formID.raw_type[3].checked)
	{
		if(browser == "NS")
			window.parent.opener.ShowWindow('kxyCrJMF','','700px','650px',["raw_format",XMLobj,"","Stream",getHandle(),getConnid(),getQType(),getBrowser(),0,"",getActiveQmgr(),getQueueName(),'',url,mbcsXML]);
		else
			window.returnValue = "Stream";
		window.parent.close();
	}
	else
	if(QType != TYPEMQ && formID.raw_type[4].checked)
	{
		if(browser == "NS")
			window.parent.opener.ShowWindow('kxyCrJMF','','700px','650px',["raw_format",XMLobj,"","Map",getHandle(),getConnid(),getQType(),getBrowser(),0,"",getActiveQmgr(),getQueueName(),'',url,mbcsXML]);
		else
			window.returnValue = "Map";
		window.parent.close();
	}
}
}



function decideStringOrHex(param2,param1,param0){

		document.XMLTreeForm.current_pos.value = "";

		if(param2 == "0"){
			document.getElementById('textareaStatus').style.display = "none";
			document.XMLTreeForm.raw_type[1].checked = true;
			document.XMLTreeForm.raw_type[0].disabled = true;
			document.XMLTreeForm.raw_type[2].disabled = true;
			if(QType != TYPEMQ && editOrCrtFlag == 1)
			{
				document.XMLTreeForm.raw_type[3].disabled = true;
				document.XMLTreeForm.raw_type[4].disabled = true;
			}
			if(param1 != null){
				//document.XMLTreeForm.XMLEntry.value = param1;
				setTextAreaContent("RAW_HEXA",param1);
			}
			hexValueFlag = 1;
			if(param0 != null)
				updateValue(param0,"hex");
			document.XMLTreeForm.raw_type[1].focus();
		}
		else
		if(param2 == "1"){
			document.XMLTreeForm.raw_type[0].checked = true;
			document.getElementById('textareaStatus').style.display = "block";
			document.XMLTreeForm.raw_type[0].disabled = false;
			document.XMLTreeForm.raw_type[1].disabled = false;
			if(!readOnly)
				document.XMLTreeForm.XMLEntry.readOnly = false;
			else
				document.XMLTreeForm.XMLEntry.readOnly = true;
			document.XMLTreeForm.raw_type[2].disabled = true;
			if(QType != TYPEMQ && editOrCrtFlag == 1)
			{
				document.XMLTreeForm.raw_type[3].disabled = true;
				document.XMLTreeForm.raw_type[4].disabled = true;
			}
			if(param1 != null){
				//document.XMLTreeForm.XMLEntry.value = param1;
				setTextAreaContent("STRING",param1);
				updateValue(param1,"hex");
			}
			hexValueFlag = 0;
			document.XMLTreeForm.raw_type[0].focus();
		}
		if(document.XMLTreeForm.XMLEntry.value == ""){
			document.XMLTreeForm.raw_type[0].disabled = false;
			document.XMLTreeForm.raw_type[1].disabled = false;
			document.XMLTreeForm.raw_type[2].disabled = false;
			if(QType != TYPEMQ && editOrCrtFlag == 1)
			{
				document.XMLTreeForm.raw_type[3].disabled = false;
				document.XMLTreeForm.raw_type[4].disabled = false;
			}
			document.XMLTreeForm.raw_type[0].focus();
		}
}




function openHexApplet(CrtOrUpd,flag)
{
	var hexFound = 0;
	var ccsidFound = 0;
	var params = new Array();

	if(flag != null && flag != "")
	{
		hexFound = 1; 
		var CCSID;
		if(message.length != 0)
		{
			if(flag == 1){
				CCSID = getTag("//characterSet",headerObj);
				if(CCSID == null || rtrim(CCSID).length == 0)
				{
					if(QType == TYPEMQ)
						CCSID = getAttrib(headerObj,"//characterSet","Default");
					else
						CCSID = 1208;
				}
			}
			if(flag == 2){
				CCSID = getTag("/*/*/Message[Header/KXY/ConnId="+con+"]/Header//characterSet",headerObj);
				if(CCSID == null || rtrim(CCSID).length == 0)
				{
					if(QType == TYPEMQ)
						CCSID = 0;
					else
						CCSID = 1208;
				}
			}
		}
		else
			CCSID = nestedCCSID;
			

		if(isNaN(CCSID) || !checkWholeNumber(CCSID)){
			M_alert(err_206);
			if(hexValueFlag == 0)
				var p2 = "1";
			else
				var p2 = "0";
			decideStringOrHex(p2)
		}
		else{
			if(kxyType != "RAW_HEXA")
				for(var i = 0; i < mbcsXML.length; i++)
				{
					if(mbcsXML[i] == CCSID)
					{
						ccsidFound = 1;
						break;
					}
				}
			if(ccsidFound == 1 && kxyType != "RAW_HEXA" && hexValueFlag == 0)
			{
				var textAreaValue = document.XMLTreeForm.XMLEntry.value;
				// replace all carriage return to '&#13'
				// because 'CR' will be missing when server receives the data
				// in getHexaValue() method
				var n = document.XMLTreeForm.XMLEntry.value.search("\r");
				var n = textAreaValue.search("\n");
				textAreaValue = textAreaValue.replace(/\r/g, '&#13');
				if(textAreaValue != ""){
				//	DCC for kxyException
					textAreaValue = M_getHex("<![CDATA["+textAreaValue+"]]>",CCSID);
				}

				params[0] = textAreaValue;
				params[1] = "hex";
				params[2] = CCSID;
			}
			else
			{
				
				if(hexValueFlag == 0)
				{
					var textAreaValue = document.XMLTreeForm.XMLEntry.value;
					params[0] = textAreaValue;
					params[1] = "ascii";
					params[2] = CCSID;
				}
				if(hexValueFlag == 1)
				{
					params[0] = returnXML;
					params[1] = "hex";
					params[2] = CCSID;
				}
			}

			params[3] = getBrowser();
			params[4] = handle;
			params[5] = connid;
			params[6] = url;
			params[7] = readOnly;
			params[8] = ccsidFound;

			if(params[0]!=undefined)
				ShowWindow('kxyHexCr','','900px','370px',params);
		}
	}
	else{
	
		var valid = 1;
		for(var u=0; u < hexArrayIndex;u++){
			if(hexFieldName[u] == hexPathSelected){
				params[0] = hexFieldValue[u];
				hexFound = 1;
				params[1] = "hex";
			}
		}
		if(hexFound == 0){
			if(CrtOrUpd == "create"){
				params[0] = nodeSel.childNodes[0].nodeValue;
				params[1] = "ascii";
			}
			else{
				var hexVal = M_getHexValue(hexPathSelected,selectedConID);
				if(hexVal != undefined && hexVal != null){
					params[0] = hexVal;
					params[1] = "hex";
				}
				else
					valid = 0;
			}
		}
		if(valid == 1)
			ShowWindow('kxyHexAp','','900px','370px',params);
	}
}

function openHexdumpApplet(CrtOrUpd,flag)
{
	var hexFound = 0;
	var ccsidFound = 0;
	var params = new Array();

	if(flag != null && flag != "")
	{
		hexFound = 1; 
		var CCSID;
		if(message.length != 0)
		{
			if(flag == 1){
				CCSID = getTag("//characterSet",headerObj);
				if(CCSID == null || rtrim(CCSID).length == 0)
				{
					if(QType == TYPEMQ)
						CCSID = getAttrib(headerObj,"//characterSet","Default");
					else
						CCSID = 1208;
				}
			}
			if(flag == 2){
				CCSID = getTag("/*/*/Message[Header/KXY/ConnId="+con+"]/Header//characterSet",headerObj);
				if(CCSID == null || rtrim(CCSID).length == 0)
				{
					if(QType == TYPEMQ)
						CCSID = 0;
					else
						CCSID = 1208;
				}
			}
		}
		else
			CCSID = nestedCCSID;
			

		if(isNaN(CCSID) || !checkWholeNumber(CCSID)){
			M_alert(err_206);
			if(hexValueFlag == 0)
				var p2 = "1";
			else
				var p2 = "0";
			decideStringOrHex(p2)
		}
		else{
			if(kxyType != "RAW_HEXA")
				for(var i = 0; i < mbcsXML.length; i++)
				{
					if(mbcsXML[i] == CCSID)
					{
						ccsidFound = 1;
						break;
					}
				}
			if(ccsidFound == 1 && kxyType != "RAW_HEXA" && hexValueFlag == 0)
			{
				var textAreaValue = document.XMLTreeForm.XMLEntry.value;
				// replace all carriage return to '&#13'
				// because 'CR' will be missing when server receives the data
				// in getHexaValue() method
				var n = document.XMLTreeForm.XMLEntry.value.search("\r");
				var n = textAreaValue.search("\n");
				textAreaValue = textAreaValue.replace(/\r/g, '&#13');
				if(textAreaValue != ""){
				//	DCC for kxyException
					textAreaValue = M_getHex("<![CDATA["+textAreaValue+"]]>",CCSID);
				}
				params[0] = textAreaValue;
				params[1] = "hex";
				params[2] = CCSID;
			}
			else
			{
				if(hexValueFlag == 0)
				{
					var textAreaValue = document.XMLTreeForm.XMLEntry.value;
					params[0] = textAreaValue;
					params[1] = "ascii";
					params[2] = CCSID;
				}
				if(hexValueFlag == 1)
				{
					params[0] = returnXML;
					params[1] = "hex";
					params[2] = CCSID;
				}
			}
			
			if(params[0]!=undefined)
				ShowWindow('kxyHexDump','','900px','370px',params);
		}
	}
}
var textStatus = 1;

function updateValue(value,flag,test,event)
{
	if(!(test != null && test == 1 && document.XMLTreeForm.raw_type[1].checked))
		returnXML = value;
	
	if(document.XMLTreeForm.raw_type[0].checked)
	{
		updateTotalBytes(value);
		if(document.XMLTreeForm.total_bytes.value > 100000)
		{
			textStatus = 0;
		}
		else
		{
			textStatus = 1;
			if(event)
				storeCaret(event);
		}
	}
	if(flag == null || (flag != null && flag == ""))
	{
		checkSelection();
	}
}



var insideStoreCaret = 0;

function storeCaret(e)
{
	if(textStatus == 1)
		if(insideStoreCaret == 0)
		{
			insideStoreCaret = 1;
			setTimeout("storeCaretPos()",100);
		}
		else
		{
			e.returnValue = false;
		}
	else
		e.returnValue = false;
}


function storeCaretPos() 
{
   var tempInput = txtInput;
   var textEl = document.XMLTreeForm.XMLEntry;
  if(document.XMLTreeForm.raw_type[0].checked)
  if (textEl.createTextRange)
  {
     tempInput=textEl.createTextRange();
     tempInput.collapse(true);
     tempInput = document.selection.createRange().duplicate();

     if(tempInput.text.length == 0)
     {
     	tempInput.moveStart('character', 0);
     	tempInput.moveEnd('textedit');
     	
     	var tempTxtInp = tempInput.text;
     	     
     	var countSelectedEnter = countInstances(tempTxtInp,'\r\n') - 4;
	if(QType == TYPEMQ || kxyType == "STRING")
	{
		if(editOrCrtFlag ==  1)
			var correctionText = 56;
		else
			var correctionText = 55;
	}
	else
	{
		if(editOrCrtFlag ==  1)
			var correctionText = 166;
		else
			var correctionText = 165;
	}
     	var temp_count = parseInt(document.XMLTreeForm.total_bytes.value) + correctionText - tempTxtInp.length + countSelectedEnter;
     if(temp_count >= 0)
     		document.XMLTreeForm.current_pos.value = temp_count;
     	else
     		document.XMLTreeForm.current_pos.value = "";
     }
 }  
 insideStoreCaret = 0;
}



function insertAtCaret (textEl, text) {
       if (textEl.createTextRange && textEl.caretPos) {
         var caretPos = textEl.caretPos;

         caretPos.text = caretPos.text.charAt(caretPos.text.length - 1) == '' ?text + ' ' : text;
       }
       else
         textEl.value  = text;
     }




var txtInput;

function setSelectionRange(input, selectionStart, selectionEnd) {
  if (input.setSelectionRange) {
    input.focus();
    input.setSelectionRange(selectionStart, selectionEnd);
  }
  else if (input.createTextRange) {
    txtInput = input.createTextRange();
    txtInput.collapse(true);
    txtInput.moveEnd('character', selectionEnd);
    txtInput.moveStart('character', selectionStart);
    txtInput.select();
  }
}


function setCaretToPos (input, pos) 
{
  var valid = 1;
  if(isNaN(pos) || !checkWholeNumber(pos) || pos < 0)
  	valid = 0;
  if(valid == 1)
  	setSelectionRange(input, pos, pos);

  document.XMLTreeForm.set_caret.value = "";
  return valid;
}

var selectionStart;
var selectionEnd;

function findSelection (input) {
  if (input.setSelectionRange) {
    selectionStart = input.selectionStart;
    selectionEnd = input.selectionEnd;
     
  }
  else if (document.selection) {
    var range = document.selection.createRange();
    if (range.parentElement() == input) {
      var isCollapsed = range.text == '';
      if (!isCollapsed)  { // there has been a selection
        //it appears range.select() should select the newly 
        //inserted text but that fails with IE
        range.moveStart('character', -replaceString.length);
        range.select();
      }
    }
  }
}

function ChangeSelection()
       {
         if (document.getSelection||window.getSelection)
         {
           var str = (window.getSelection)?getSelection():document.getSelection();
         }
         else if (document.selection && document.selection.createRange)
         {
           var range = document.selection.createRange();
           var str = range.text;
         }

         else
         {
            var str = "Sorry, this is not possible with your browser.";
         }

         //document.forms['myForm'].myTextDisplay.value = str;// using standard referencing makes it Netscape compatible            
       } 



function updateTotalBytes(val)
{
	var currentTotalBytes = countInstances(val, '\r\n');
	document.XMLTreeForm.total_bytes.value = val.length - currentTotalBytes;
	if(document.XMLTreeForm.current_pos.value.length == 0)
		document.XMLTreeForm.current_pos.value = document.XMLTreeForm.total_bytes.value;
}





function OpenHelpDialog(){

if(headerEOpen == 1)
	if(QType == TYPEMQ)
		ShowMyHelp('header_editor_wmq');
	else
		ShowMyHelp('header_editor_jms');
else
if(propertyEOpen == 1)
	ShowMyHelp('property_editor_jms');
else
{
	if(document.XMLTreeForm.raw_type != null)
		ShowMyHelp('text_editor');
	else
	{
		if(body_type == "Map")
			ShowMyHelp('map_editor');
		else
		if(body_type == "Stream")
			ShowMyHelp('stream_editor');
		else
			ShowMyHelp('tree_editor');
	}
}
}





function openXMLEditor(XMLString){
if (document.implementation && document.implementation.createDocument)
{
   // netscape 6.x+ support
	  new_obj = document.implementation.createDocument("","", null);

}
else if (window.ActiveXObject)
{
  // ie 5.x+ support
  //MSXML2.DOMDocument
  //new_obj = new ActiveXObject("Microsoft.XMLDOM");
   new_obj = new ActiveXObject("MSXML2.DOMDocument");

}
 else
 {
   M_alert(err_209);
   return;
 }
var unValid = 0;

if(rtrim(ltrim(XMLString)).length == 0){
	unValid = 1;
	ShowWindow('kxyNodes','','450px','240px',['',7,getBrowser()]);
}
else{
	if(browser == "NS"){
	    	new_obj = createXMLFromString(XMLString);
	}else
		new_obj.loadXML(XMLString);

	if(browser == "NS" && (new_obj.childNodes[0].nodeName == "parsererror" || (new_obj.childNodes[1] != null && new_obj.childNodes[1].nodeName == "parsererror"))){
		unValid = 1;
		M_alert(err_204);
	}
	if(browser != "NS")
	if(new_obj.childNodes[0] == null){
		unValid = 1;

		if(new_obj.childNodes[0] != null && new_obj.childNodes[0].nodeType == 8)
			M_alert(err_210);
		else
			M_alert(err_204);
	}
}
	
if(unValid == 0)
	ShowWindow('kxyXMLTr','','690px','650px',[XMLString,browser,readOnly]);
checkSelection();

}


////////////////////////////////////////////////////////////////////////////////////////////////////
//			Properties  editor
////////////////////////////////////////////////////////////////////////////////////////////////////

var screenXMain = 0;
var nodeProp;

function openPropertyEditor(flag,kxyType)
{
	propertyEOpen = 1;
	headerEOpen = 0;
	var temp = document.getElementById('treeSubH1');
	if(temp)
		temp.innerHTML = "";
	if(document.getElementById('treeSubH0').style.display == "block")
		showOtherProperties();
	document.getElementById('headerHead').style.display = "none"; 
	document.getElementById('PropDiv').style.display = "block"; 
	document.getElementById('treeSub0').style.display = "none"; 

	document.getElementById('headProp_buttons').style.left = "280"; 

	document.getElementById('buttons').style.display = "none";
		
	document.getElementById('headProp_buttons').style.display = "block";
	
	showWidth = 440;

if((flag == 1 && getTag("//ReturnCode",headerObj) != "Exception") || flag == 2){
	
	if(QType != TYPEMQ)
		document.getElementById('editJ').src = "images/editJMSprop.gif";	
	window.center='yes';

	var html = "";
	var h = showHeight - 150;
	html += "<DIV id='propertyEditor' STYLE='height:"+h+";width:570;overflow:auto' class='treeView' >";
	html += "<table width='100%' border='0' cellpadding='3' cellspacing='0' >";



	if(flag == 1){
	   if(propObj == null)
	   {
		if (document.implementation && document.implementation.createDocument)
 		{
 		  // netscape 6.x+ support
			  propObj = document.implementation.createDocument("","", null);
 		}
 		else if (window.ActiveXObject)
 		{
 		  // ie 5.x+ support
  			  //propObj = new ActiveXObject("Microsoft.XMLDOM");
  		//MSXML2.DOMDocument
			   	propObj = new ActiveXObject("MSXML2.DOMDocument");

  		}
  		else
 		   return;


 		if(browser == "NS"){
	 		var stringToLoad = "<?xml version='1.0' ?><Properties></Properties>";
 		}
 		else{
 		  	var stringToLoad = "<Properties></Properties>";
 		}


		if(browser == "NS"){
		     var objParser = new DOMParser();
		     propObj = objParser.parseFromString(stringToLoad, "text/xml");

		}
		else
			propObj.loadXML(stringToLoad);
	   }
	   nodeProp = propObj.childNodes[0];	   	
	   html += "<tr><td valign='top' height='20'><img id='prop' align='middle' src='images/msg_menu.gif' onMouseOut=hidePopupMenu('propM') onMouseDown=onMouseDownProp(event,'prop',"+flag+") ><font class='dark'><b>" + nodeProp.nodeName + "</b></font>";
	}
	else
	if(flag == 2){
		nodeProp = getXMLTag("/*/*/Message[Header/KXY/ConnId="+con+"]/Properties",XMLobj);
		if(browser == "NS")
			nodeProp = nodeProp.iterateNext();
		if(nodeProp == null)
		{
			var node = getXMLTag("/*/*/Message[Header/KXY/ConnId="+con+"]",XMLobj);
			var newN = XMLDOMobj.createElement("Properties");
			node.appendChild(newN);
			nodeProp = getXMLTag("/*/*/Message[Header/KXY/ConnId="+con+"]/Properties",XMLobj);
		}
		html += "<td valign='top'><img align='bottom' id='prop' src='images/msg_menu.gif' onMouseOut=hidePopupMenu('propM') onMouseDown=onMouseDownProp(event,'prop') >&nbsp;&nbsp;";
		html += "<font class='dark'><b>Properties</b></font>";
	}


	html += "</td></tr><tr><td valign='top'><div id='treeSubP1'></div>";
	html += "</td></tr>";
	html += "</table>";
	html += "</DIV>";

	document.getElementById('treeSubProp0').innerHTML = html;
	
	if(browser == "NS"){
		if(window.innerWidth < 850)
		{
	    		window.resizeTo('850','700');
	    		screenXMain = window.screenX;
	    		window.screenX = '10';
	    	}
	}
	else
	{
		if(window.dialogWidth != '700')
		{
			window.dialogWidth='700px';
			window.dialogLeft=screenXMain;
		}
	}

	if(document.getElementById('alertDiv') != null)
	{
		document.getElementById('alertDiv').style.width = "570";
		document.getElementById('alertDiv').style.height = "50";
		document.getElementById("showAlert").style.position="absolute";
		document.getElementById("showAlert").style.left=60;
		document.getElementById("showAlert").style.top=480;
		
		document.getElementById('propertyEditor').style.height = '370';
		if(browser == "NS")
		{
			document.getElementById("alertDiv").style.position="absolute";
			document.getElementById("alertDiv").style.left=40;
			document.getElementById("alertDiv").style.top=500;
		}
	}
	else
	{		
		document.getElementById('propertyEditor').style.height = '460';
	}
	
	
	if(browser == "NS"){
	
		document.getElementById("buttons").style.position="absolute";
		document.getElementById("buttons").style.top=600;
		document.getElementById("buttons").style.left=400;
	
		document.getElementById("headerHead").style.position="absolute";
		document.getElementById("headerHead").style.top='55';
		document.getElementById("headerHead").style.width='500';
		
	}

	
	if(flag == 2 && nodeProp != null)
		subNodesProperty('nodeProp',nodeProp,'P1',1,2,1);
	if(flag == 1)	
		subNodesProperty('nodeProp',nodeProp,'P1',1,1,1);
		
}
else
	M_alert(err_207);
}



function hideNode(id)
{
	if(document.getElementById(id).style.display == "block")
	{
		document.getElementById(id).style.display = "none";
		document.getElementById('img_'+id).src = "images/plus.gif";
	}
	else
	{
		document.getElementById(id).style.display = "block";
		document.getElementById('img_'+id).src = "images/minus.gif";
	}
}



function subNodesProperty(nodeString,nodeVal,divVal,cVal,flag,testFlag)
{
	var tree = "";
	tree += "<table>";
	if((testFlag != 2 && document.getElementById('treeSubP1').innerHTML != "") || (testFlag != null && testFlag == 0)){
		propertyEOpen = 0;
		document.getElementById('treeSubProp0').innerHTML = "";
		document.getElementById('treeSub0').style.display = "block";
		document.getElementById('PropDiv').style.display = "none";
		document.getElementById('buttons').style.display = "block";
		
		document.getElementById('headProp_buttons').style.display = "none";

		if(browser == "NS"){
	    		window.resizeTo('700','700');
	    		window.screenX = screenXMain;
			
			document.getElementById("buttons").style.position="absolute";
			document.getElementById("buttons").style.left=250;
		}
		else
		{
			window.dialogWidth='700px';
			window.dialogLeft = screenXMain;
		}
		if(document.getElementById('alertDiv') != null)
		{
			document.getElementById('alertDiv').style.width = "570";
			document.getElementById('alertDiv').style.height = "60";

			showHeight = 410;
			if(browser == "NS")
			{
				document.getElementById("alertDiv").style.position="absolute";
				document.getElementById("alertDiv").style.left=50;
				document.getElementById("alertDiv").style.top=500;
			}
		}
		else
		{
			showHeight = 500;
		}
		
		if(QType != TYPEMQ)
			document.getElementById('editJ').src = "images/editJMS.gif";		
		
	}
	else
	if(nodeVal != null)
	{
	if(cVal != 0){
		nodeVal = nodeVal.childNodes;
		nodeValue = nodeString + ".childNodes";
	}
	else{
		if(browser == "NS"){
			nodeVal = nodeVal[1].childNodes;
			nodeValue = nodeString + "[1].childNodes";
		}
		else{
			nodeVal = nodeVal[0].childNodes;
			nodeValue = nodeString + "[0].childNodes";
		}
	}
	for(var i=0;i<nodeVal.length;i++){
		if(nodeVal[i].nodeName != "#text")
		{
			var pName = nodeVal[i].nodeName ;
			if(nodeVal[i].attributes != null)
				var pType = nodeVal[i].attributes.item(0).nodeValue ;
			else 
				var pType =  '';
			if(nodeVal[i].hasChildNodes())
			{	
				if(browser == "NS")
					var pValue = serializeXML(nodeVal[i].firstChild);
				else
					var pValue = nodeVal[i].firstChild.xml;
			}
			
			tree += "<tr><td nowrap>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src='images/minus.gif' id ='img_"+divVal+"_"+i+"' height=12 width=12 onClick = hideNode('"+divVal+"_"+i+"') >";
			tree += "&nbsp;&nbsp;&nbsp;<img src='images/msg_menu.gif' id='prop_"+divVal+"_"+i+"' ";
			if(nodeVal[i].hasChildNodes())
				tree += " valN ='"+pValue+"' ";
			else
				tree += " valN = '' ";
			tree += " onMouseOut=hidePopupMenu('propM2') onMouseDown=onMousePropEdit(event,'prop_"+divVal+"_"+i+"','"+pName+"','"+pType+"',this.getAttribute('valN'),"+i+") >";
			tree += "&nbsp;&nbsp;&nbsp;<font class='dark'><b>" + pName + "</b></font><br/>";
			tree += "<div id = '"+divVal+"_"+i+"' style='display:block'>";
			for(var q = 0; q < 5; q++)
				tree += "<img src='images/white.gif' align='absmiddle' border='0'>";
			tree += "<font class='dark'><b>Type </b></font>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<font class='Attribute'><b>" + pType + "</b></font><br/>";
			for(var q = 0; q < 5; q++)
				tree += "<img src='images/white.gif' align='absmiddle' border='0'>";
			tree += "<font class='dark'><b>Value </b></font>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
			if(nodeVal[i].hasChildNodes())
				tree += "<font class='Attribute'><b>"+ pValue + "</b></font>";
			tree += "</div></td></tr>";
		}

	}
	tree += "</table>";

	document.getElementById('treeSubP1').innerHTML = tree;
}
	if(document.getElementById('treeSubProp0').innerHTML != "")
		iteration -= 1;

}


function displayDelete(flag,iter)
{
	ShowWindow('kxydelMW','','440px','190px',['',getBrowser(),flag,iter]);
}



function addProperty(flag)
{
	ShowWindow("kxyAdPro",'','480px','480px',[getBrowser(),'',flag]);
}

var con;
function removeProperty()
{
if(con != null)
	var countP = count("/*/*/Message[Header/KXY/ConnId="+con+"]/Properties/*",XMLobj);
else
	var countP = count("//Properties/*",nodeProp);
if(countP == 0)
{
	M_alert("There are no properties to remove.");
}
else
{
	if(browser == "NS")
	{
		if(con != null)
			ShowWindow("kxyRePro",'','480px','480px',[getBrowser(),XMLobj,con]);
		else
			ShowWindow("kxyRePro",'','480px','480px',[getBrowser(),nodeProp,con]);	
	}
	else
		ShowWindow("kxyRePro",'','480px','480px',[getBrowser(),nodeProp.cloneNode("true")]);
}
}


function editProperty(propAttr,flag)
{
	ShowWindow("kxyAdPro",'','480px','480px',[getBrowser(),propAttr,flag]);
}

function deleteProperty(iter,name)
{
	if(name != null)
	{
		for(var i = 0; i < count("//Properties/*",nodeProp); i++)
		{
			if(nodeProp.childNodes[i].nodeName == name)
			{
				nodeProp.removeChild(nodeProp.childNodes[i]);
				subNodesProperty('nodeProp',nodeProp,'P1',1,2,2);
				break;
			}
		
		}
	}
	else
	{
		if(nodeProp.childNodes[iter] != null)
		{
			nodeProp.removeChild(nodeProp.childNodes[iter]);
			subNodesProperty('nodeProp',nodeProp,'H1',1,2,2);
		}
	}
}


function onMouseDownProp(e,tag,flag)
{
	if(browser != "NS")
	{
		var e = event;	
		if(e.button == 1 || e.button == 2 || e.button == 3)
			showMenuProperty(tag,flag);
		
	}
	if(browser == "NS" && (e.which==1 || e.which==3 || e.which==2))
	{
     		showMenuProperty(tag,flag);
    	}
}



function onMousePropEdit(e,tag,propN, propT, propV,iter)
{
	if(browser != "NS")
	{
		var e = event;	
		if(e.button == 1 || e.button == 2 || e.button == 3)
			showPropEditMenu(e,tag,[propN, propT, propV,iter]);
		
	}
	if(browser == "NS" && (e.which==1 || e.which==3 || e.which==2))
	{
     		showPropEditMenu(e,tag,[propN, propT, propV,iter]);
    	}

}



function showPropEditMenu(e,tag,propAttr)
{
    //var pos = getAnchorPosition(tag,'msg');

    var x=y=0;
	    if (e != '') {
	        x = e.screenX;
	        y = e.screenY;
    }
	if(browser == "NS")
	{
		x = x - self.screenX + 5;
		y = y - self.screenY - 20;
	}
	else
	{
		x = x - self.screenLeft + 10;
		y = y - self.screenTop + 7;
	}
   showPopupMenu('propM2',x - 10,y,'',propAttr,'');
}



function showMenuProperty(tag,flag)
{
    var x=y=0;
/*	    if (e != '') {
	        x = e.screenX;
	        y = e.screenY;
    }
*/
	var pos = getAnchorPosition(tag,'msg');

	x = pos.x;
	y = pos.y;
	if(browser == "NS")
	{
		x = x + 25;
		y = y + 49;
	}
	else
	{
		y = y - 5;
	}
   showPopupMenu('propM',x + 10,y +20,'',flag,'');
}


function createProperty(name, type, val,flag)
{
	var auxValue;
	var newnode;
	if(flag != null && flag == 1)
	{
		newnode=propObj.createElement(name);
		auxValue=propObj.createTextNode(val);
		var newAttr=propObj.createAttribute("Type");	
	}
	else
	{
		newnode=XMLDOMobj.createElement(name);
		auxValue=XMLDOMobj.createTextNode(val);
		var newAttr=XMLDOMobj.createAttribute("Type");
	}
	nodeProp.appendChild(newnode);
	newnode.appendChild(auxValue);
	newAttr.value = type;
	newnode.setAttributeNode(newAttr);
	
	if(flag != null && flag == 1)	
		subNodesProperty('nodeProp',nodeProp,'P1',1,1,2);
	else
		subNodesProperty('nodeProp',nodeProp,'P1',1,2,2);
}


function updateProperty(name, type, val,iter)
{
	if(!nodeProp.childNodes[iter].hasChildNodes())
	{
		var newnode = XMLDOMobj.createTextNode('');
		nodeProp.childNodes[iter].appendChild(newnode);
	}
	nodeProp.childNodes[iter].firstChild.nodeValue = val;
	nodeProp.childNodes[iter].attributes.item(0).nodeValue = type;
	subNodesProperty('nodeProp',nodeProp,'P1',1,2,2);
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//			Header editor
////////////////////////////////////////////////////////////////////////////////////////////////////
var nodeHead;

function openHeaderEditor(flag,kxyType)
{
	headerEOpen = 1;
	propertyEOpen = 0;
	if(QType != TYPEMQ)
	{
		document.getElementById('treeSubProp0').innerHTML = "";
		document.getElementById('PropDiv').style.display = "none";
		
	}
	document.getElementById('treeSub0').style.display = "none";
	if(document.getElementById('treeSubH0').style.display == "block")
		showOtherProperties();
	//document.getElementById('buttons').style.position = "absolute"; 
	document.getElementById('headProp_buttons').style.left = "330"; 
	//document.getElementById('buttons').style.top = "570"; 
	
	document.getElementById('buttons').style.display = "none";
		
	document.getElementById('headProp_buttons').style.display = "block";
		
	editHeaderFlag = 1;
	showWidth = 440;


if((flag == 1 && getTag("//ReturnCode",headerObj) != "Exception") || flag == 2){
	
	if(browser == "NS"){
		if(window.innerWidth < 850)
		{
	    		window.resizeTo('850','700');
	    		screenXMain = window.screenX;
	    		window.screenX = '10';
	    	}
	}
	else
	{
		if(window.dialogWidth != "850px")
		{
			widthScreen = document.body.clientWidth;
			window.dialogLeft = widthScreen/2 - 300;
			window.dialogWidth='850px';
		}
	}
	

	
	if(QType != TYPEMQ)
		document.getElementById('editJ').src = "images/editJMShead.gif";	
	window.center='yes';

	var html = "";
	var h;
	
	if(flag == 2)
	{
		h = showHeight/2 - 60;
		html += "<DIV id='headerEditor' STYLE='height:"+h+";width:750;overflow:auto' class='treeView' >";
	}	
	else
	{
		h = showHeight- 75;
		html += "<DIV id='headerEditor' STYLE='height:"+h+";width:750;overflow:auto' class='treeView' >";
	}	
	html += "<table width='100%' height='100%' border='0' cellpadding='3' cellspacing='0'>";

	if(flag == 1){
		if(browser == "NS")
			xmlHeader = headerObj.childNodes[1].childNodes[3].childNodes;
		else
			xmlHeader = headerObj.childNodes[1].childNodes[1].childNodes;		
	}
	if(flag == 1)
	{
		document.getElementById('head1').innerHTML = "<font class='ListHeader'><b>Message Descriptor</b></font>";
		document.getElementById('head2Table').style.display = "none";
	}
	else
		if(flag == 2)
			document.getElementById('head1').innerHTML = "<font class='ListHeader'><b>PathWAI Editor Properties</b></font>";
	
	html += "<tr><td valign='top'><div id='treeSubH1'></div>";
	html += "</td></tr>";
	html += "</table>";
	html += "</DIV>";

	document.getElementById('treeSubH0').innerHTML = html;
	document.getElementById('headerHead').style.display='block';
	document.getElementById('head0').innerHTML='<font><b>Header Editor</b></font>';

	if(flag == 1 && kxyType != "MDR_RAW")
	{
		html = "";
		html += "<DIV id='headerEditor2' STYLE='height:30;width:750;overflow:auto;' class='treeView' >";
		html += "<table width='100%' height='100%' border='0' cellpadding='3' cellspacing='0' >";
		html += "<tr><td valign='top'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<font class='dark'><b>XMLEncoding<b></font>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type = 'text' name='XMLEn' value ='"+ XMLEncodingVal +"' onChange=updateEncoding(this.value) >";
		html += "</td></tr>";
		html += "</table>";
		html += "</DIV>";

		document.getElementById('treeSubHD0').innerHTML = html;
		document.getElementById('head2').innerHTML = "<font class='ListHeader'><b>PathWAI Editor Properties</b></font>";
		document.getElementById('head2Table').style.display = "block";
	}
	
	if(flag == 1 && (document.XMLTreeForm.raw_type == null || (document.XMLTreeForm.raw_type != null && !document.XMLTreeForm.raw_type[2].checked)))
		handleXMLEncoding("none");
	else
		handleXMLEncoding("block");
	if(flag == 2)
	{
		html = "";
                //if(QType == TYPEMQ)
                	h = 400;
		html += "<DIV id='headerEditor2' STYLE='height:"+h+";width:750;overflow:auto' class='treeView' >";
		html += "<table width='100%' height='100%' border='0' cellpadding='3' cellspacing='0'>";
		html += "<tr><td valign='top'><div id='treeSubHD1'></div>";
		html += "</td></tr>";
		html += "</table>";
		html += "</DIV>";

		document.getElementById('treeSubHD0').innerHTML = html;
		document.getElementById('head2Table').style.display = "block";
		
		if(browser == "NS")
		{
			subNodesHeader('node3[1].childNodes[1].childNodes',node3[1].childNodes[1].childNodes,'H1',0,2);
			subNodesHeader('node3[1].childNodes[3].childNodes',node3[1].childNodes[3].childNodes,'HD1',0,2);
		}
		else
		{
			subNodesHeader('node3[0].firstChild.childNodes',node3[0].firstChild.childNodes,'H1',0,2);
			subNodesHeader('node3[0].childNodes[1].childNodes',node3[0].childNodes[1].childNodes,'HD1',0,2);		
		}
	}
		
	if(browser == "NS"){
		
		document.getElementById("buttons").style.position="absolute";
		document.getElementById("buttons").style.top=600;
		document.getElementById("buttons").style.left=400;	
		
		document.getElementById("headerHead").style.position="absolute";
		document.getElementById("headerHead").style.top='55';
		document.getElementById("headerHead").style.width='500';
		if(body_type == "Map" || body_type == "Stream")
		{
			document.getElementById('treeSub0').style.width = '450';
			document.getElementById("treeSub0").style.position="absolute";
			document.getElementById("treeSub0").style.top='55';
			document.getElementById("treeSub0").style.left='500';		
		}
	}
	if(document.getElementById('alertDiv') != null)
	{
		document.getElementById('alertDiv').style.width = "770";
		document.getElementById('alertDiv').style.height = "50";
		document.getElementById("showAlert").style.position="absolute";
		document.getElementById("showAlert").style.left=39;
		document.getElementById("showAlert").style.top=480;
		
		if(flag == 2 || (flag == 1 && kxyType != "MDR_RAW" && kxyType != "STANDALONE"))
			document.getElementById("headerEditor2").style.height='310';

		if(flag == 1 && document.XMLTreeForm.raw_type != null && document.XMLTreeForm.raw_type[2].checked) //kxyType == "STANDALONE")
			document.getElementById("headerEditor2").style.height='30';
		if(browser == "NS")
		{
			document.getElementById("alertDiv").style.position="absolute";
			document.getElementById("alertDiv").style.left=40;
			document.getElementById("alertDiv").style.top=500;
		}
	}
	
	
	if(flag == 1)	
	{
		if(browser == "NS")
			subNodesHeader('xmlHeader[1].childNodes',xmlHeader[1].childNodes,'H1',0,1);
		else
			subNodesHeader('xmlHeader[0].childNodes',xmlHeader[0].childNodes,'H1',0,1);
	}		
}
else
	M_alert(err_207);
}




function subNodesHeader(nodeString,nodeVal,divVal,cVal,flag,testFlag){

	tree = "";

	tree += "<table align='left' width='100%' border='0'>";

	if(document.getElementById('treeSub' + divVal).innerHTML != "" || (testFlag != null && testFlag == 0))
	{
		headerEOpen = 0;
		if(document.getElementById('treeSubH0').style.display == "block")
			showOtherProperties();
		document.getElementById('treeSubH0').innerHTML = "";
		document.getElementById('headerHead').style.display='none';
		//document.getElementById('buttons').style.left = "270";
		document.getElementById('buttons').style.display = "block";
		
		document.getElementById('headProp_buttons').style.display = "none";
		
		if(document.getElementById('treeSubHD0') != null)
			document.getElementById('treeSubHD0').innerHTML = "";
		if(browser == "NS"){
	    		window.resizeTo('700','700');
	    		window.screenX = screenXMain;

			if(body_type == "Map" || body_type == "Stream")
			{
				document.getElementById("treeSub0").style.position="absolute";
				document.getElementById("treeSub0").style.left=-30;
				document.getElementById("treeSub0").style.width=760;
			}
			else
			{
				document.getElementById("bodyEdit").style.position="absolute";
				document.getElementById("bodyEdit").style.left=43;
			}

			document.getElementById("buttons").style.position="absolute";
			document.getElementById("buttons").style.left=250;
		}
		else
		{
			window.dialogWidth='700px';
			window.dialogLeft = screenXMain;
		}
		if(document.getElementById('alertDiv') != null)
		{
			document.getElementById('alertDiv').style.width = "600";
			document.getElementById('alertDiv').style.height = "60";
			document.getElementById('treeSub0').style.left=60;
			
			if(browser == "NS")
			{
				document.getElementById("alertDiv").style.position="absolute";
				document.getElementById("alertDiv").style.left=50;
				document.getElementById("alertDiv").style.top=500;
			}
		}

		
		if(QType != TYPEMQ)
			document.getElementById('editJ').src = "images/editJMS.gif";		
		
		headerOpen = 0;
		document.getElementById('treeSub0').style.display = "block";	
	}
	else{
	headerOpen = 1;
	for(var i=0;i<nodeVal.length;i++){
	
	if(nodeVal[i].nodeName != "#text")
		 if(nodeVal[i].nodeName != 'MessageSequenceNumber' && nodeVal[i].nodeName != 'ConnId' && nodeVal[i].nodeName != 'KXY_TYPE' && nodeVal[i].nodeName != 'QueueDepth' ){
		if(nodeVal[i].nodeName == "XMLEncoding" && editOrCrtFlag == 1)
			tree += "<tr><td width='60%'><div id='xmlEncoding' style='display:none'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<font class='dark'><b>" + nodeVal[i].nodeName + "</b></font></div></td>";
		else
			tree += "<tr><td width='60%'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<font class='dark'><b>" + nodeVal[i].nodeName + "</b></font></td>";
		if( nodeVal[i].hasChildNodes())
		{
			var name = nodeVal[i].nodeName;
			var val = nodeVal[i].childNodes[0].nodeValue;
			
			if(name == "XMLEncoding" && editOrCrtFlag == 1)
				tree += "<td align='left'><div id='xmlEncodeVal' style='display:none'>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<font class='dark'><b><input type = 'text' ";
			else
				tree += "<td align='left'>&nbsp;&nbsp;<font class='dark'><b><input type = 'text' ";
			var len = rtrim(ltrim(val)).length;
			len = len + len/3;
			tree += " size='"+len+"' ";
		 	
		 	if(nodeVal[i].nodeName == 'format'  && editOrCrtFlag == 1)
		 	if(format == "raw_format")
		 	{
		 		if(document.XMLTreeForm.raw_type[0].checked && val == "")
		 		{
					tree += "MQSTR";
		 			nodeVal[i].childNodes[0].nodeValue = "MQSTR";
		 		}
		 		else
		 		if(!document.XMLTreeForm.raw_type[0].checked && val == "MQSTR")
		 		{
					tree += "";
		 			nodeVal[i].childNodes[0].nodeValue = "";
		 		}
		 	}
		 	
			if(name == 'pFormat'){
				var fmt_name="";
				if(nodeVal[i].childNodes[0] != null){
					var fmt = val;
					for(var k=1;k<fmt.length;k++){
						if(fmt.charAt(k) == ":")
					  		fmt_name = fmt.substring(k+1,fmt.length);
					}
				}
				else
					fmt_name = ""; 	
					
				tree += " disabled value ='" + fmt_name + "' onChange='"+nodeString +"["+i+"].childNodes[0].nodeValue = this.value' /></b></font>";
			}else
			{
				if(readOnly)
					tree += " disabled value =\"" + val + "\" onChange='"+nodeString +"["+i+"].childNodes[0].nodeValue = this.value' /></b></font>";
				else
					tree += " value =\"" + val + "\" onChange='"+nodeString +"["+i+"].childNodes[0].nodeValue = this.value' /></b></font>";
			}
			if(name == "XMLEncoding" && editOrCrtFlag == 1)
				tree += "</div>";
			tree += "</td></tr>";
		}
		else{
			var theData ='';
			if(flag == 1)
				var txtNode = headerObj.createTextNode(theData);
			else
			if(flag == 2)
				var txtNode = XMLDOMobj.createTextNode(theData);

			nodeVal[i].appendChild(txtNode);
			
			if(nodeVal[i].nodeName == "characterSet"){
				var defaultValue = 0;
				defaultValue = nodeVal[i].attributes.item(0).nodeValue;
				nodeVal[i].childNodes[0].nodeValue = defaultValue;
				tree += "<td align='left'>&nbsp;&nbsp;<font class='dark'><b><input type = 'text' value = '"+ defaultValue +"' onChange='"+nodeString +"["+i+"].childNodes[0].nodeValue = this.value' ";
			 }
			 else
			if(nodeVal[i].nodeName != "format"){
				tree += "<td align='left'>&nbsp;&nbsp;<font class='dark'><b><input type = 'text' onChange='"+nodeString +"["+i+"].childNodes[0].nodeValue = this.value' ";
			 }
		 	else{
		 		tree += "<td align='left'>&nbsp;&nbsp;<font class='dark'><b><input type = 'text' id='input_format' value = '";
		 		if(format == null)
		 			format = "";
		 		if(format != "raw_format"){
		 			if(updateMQMD != null && updateMQMD == "true")
		 			{
		 				tree += "";
		 				nodeVal[i].childNodes[0].nodeValue = "";
		 			}
		 			else
		 			{
		 				tree += format;
		 				nodeVal[i].childNodes[0].nodeValue = format;
		 			}
		 		}
		 		else{
		 			tree += "MQSTR";
		 			nodeVal[i].childNodes[0].nodeValue = "MQSTR";
		 		}
		 		tree += "' onChange='"+nodeString +"["+i+"].firstChild.nodeValue = this.value' ";
		 	 }
			 if(readOnly || nodeVal[i].nodeName == "pFormat")
		  		tree += " disabled /></b></font></td></tr>";	
		 	 else
		  		tree += " /></b></font></td></tr>";
		  		
		}
	
	  }


	}
	tree += "</table>";

	document.getElementById('treeSub' + divVal).innerHTML = tree;

}
	if(document.getElementById('treeSubH0').innerHTML != "")
		iteration -= 1;
}



function showOtherProperties()
{
	if(document.getElementById('treeSubH0').style.display == "none")
	{
		document.getElementById('treeSubH0').style.display = "block";
		if(document.getElementById('alertDiv') != null)
			document.getElementById('headerEditor2').style.height = "150";
		else
			document.getElementById('headerEditor2').style.height = "200";
		document.getElementById('tri').src = 'images/triopen.gif';
	}
	else
	{
		document.getElementById('treeSubH0').style.display = "none";
		if(document.getElementById('alertDiv') != null)
			document.getElementById('headerEditor2').style.height = "300";
		else
			document.getElementById('headerEditor2').style.height = "400";
		document.getElementById('tri').src = 'images/triclose.gif';
	}
}



function openNodesDialog(node_name,type,flag){
	if(!checkReadOnlyOption())
		ShowWindow('kxyNodes','','460px','250px',[node_name,type,getBrowser(),flag]);
	else
		M_alert(err_208);
}


function displayAlert(message){
html = "<table width:600 border='1' cellpadding='0' cellspacing='0'>";
html += "<tr><td class='bg4'>&nbsp;&nbsp;&nbsp;<font><b>Error Message</b></font></td></tr>";
html += "<tr><td><DIV id='alertDiv' STYLE='height:60;width:600;overflow:auto' class='treeView' >";
html += "<table width='100%' height='100%' class='bg6'><tr><td><img src='images/alert_grey.gif' align='middle' /><font class='dark'><b>"+ message+"</b></font></td></tr></table>";
html += "</DIV></td></tr></table>";
document.getElementById('showAlert').innerHTML = html;

}



function checkReadOnlyOption(){
	return readOnly;
}


function countInstances(string, word) 
{
  var substrings = string.split(word);
  return substrings.length - 1;
}


function replaceTextArea(string,text,by) {
// Replaces text with by in string
    var strLength = string.length, txtLength = text.length;
    if ((strLength == 0) || (txtLength == 0)) return string;

    var i = string.indexOf(text);
    if ((!i) && (text != string.substring(0,txtLength))) return string;
    if (i == -1) return string;

    var newstr = string.substring(0,i) + by;

    if (i+txtLength < strLength)
        newstr += replaceTextArea(string.substring(i+txtLength,strLength),text,by);

    return newstr;
}

function StringBuffer()
{ 
	this._strings_ = new Array(); 
}
 
StringBuffer.prototype.append = function(str){ 
	this._strings_.push(str); 
} 

StringBuffer.prototype.toString = function() { 
	return this._strings_.join(""); 
}

function setTextAreaContent(raw,val)
{
	var textareaDiv = document.getElementById('textAreaVal');		
	var textareaBuffer = new StringBuffer();	
	textareaBuffer.append("<textarea TABINDEX=4 rows='"+rowN+"' cols='95'  id='XMLEntry' onClick='storeCaret(event);if(document.XMLTreeForm.raw_type[1].checked)setCursorDialog(94);' onKeyUp=updateValue(this.value,'',1,event); onFocus='fieldOnFocus = 4;'");
	if(checkReadOnlyOption() || raw == "RAW_HEXA"){
		textareaBuffer.append(" READONLY ");
	}
	textareaBuffer.append(">");
	textareaBuffer.append(val);
	textareaBuffer.append("</textarea>");
	textareaDiv.innerHTML=textareaBuffer.toString();
}
function displayTextArea(raw,val)
{
var treeBuffer = new StringBuffer();
var treeSub = document.getElementById('treeSub0');

//var tree = "<DIV id ='bodyEdit' STYLE='height:"+showHeight+";width:620;overflow:auto' class='scroll' >";
//treeBuffer.append("<XML id=xmldata></XML>");
treeBuffer.append("<DIV id ='bodyEdit' STYLE='height:"+showHeight+";width:620;overflow:auto' class='scroll' >");
treeBuffer.append("<table width='100%' height='100%' border='0' cellpadding='3' cellspacing='0' style='table-layout:fixed'>");
treeBuffer.append("<tr><td><table width='80%' height ='100%' border='1' cellpadding='2' cellspacing='0' class='bg2'><tr><td class='bg4' nowrap height='10'>");
treeBuffer.append("<font><b>&nbsp;&nbsp;Type of Message</b></font></td></tr>");
treeBuffer.append("<tr><td class='bg6' nowrap valign='top'><input type ='radio' name='raw_type' value='RAW_TEXT' onClick=checkSelection()>&nbsp;&nbsp;<font class='ListValue'><b>String</b></font>");
treeBuffer.append("<br/><input type ='radio' name='raw_type' value='RAW_HEXA' onClick=checkSelection(); >&nbsp;&nbsp;<font class='ListValue'><b>Hexadecimal</b></font>");
treeBuffer.append("<br/><input type ='radio' name='raw_type' onClick=checkSelection() value='STANDALONE'>&nbsp;&nbsp;<font class='ListValue'><b>XML</b></font>");
if(QType != TYPEMQ && editOrCrtFlag == 1)
{
	treeBuffer.append("<br/><input type ='radio' name='raw_type' value='Stream' onClick=checkSelection(); >&nbsp;&nbsp;<font class='dark'><b>Stream</b></font>");
	treeBuffer.append("<br/><input type ='radio' name='raw_type' value='Map' onClick=checkSelection(); >&nbsp;&nbsp;<font class='dark'><b>Map</b></font>");
}
treeBuffer.append("<br/><input type ='radio' name='raw_type' id='hexdump' value='HEXDUMP' onClick=checkSelection(); >&nbsp;&nbsp;<font class='ListValue'><b>Hexadecimal (dump)</b></font>");
treeBuffer.append("</td></tr></table></td>");
treeBuffer.append("<td  valign='top' align='left'><div id='XMLOption' style='display:none'>");
treeBuffer.append("<table width='90%' height ='100%' border='1' cellspacing='0' cellpadding='1'><tr><td class='bg4' nowrap height='10'><font><b>&nbsp;&nbsp;Type of XML Editor&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</b></font></td></tr><tr><td class='bg6' nowrap valign='top'><input type ='radio' name='optionXML' value='textArea' checked=true>&nbsp;&nbsp;<font class='ListValue'><b>Text Area</b></font>");
treeBuffer.append("<br/><input type ='radio' name='optionXML' value='XMLTree' onClick='openXMLEditor(document.XMLTreeForm.XMLEntry.value)'>&nbsp;&nbsp;<font class='ListValue'><b>XML Tree Editor</b></font></td></tr></table></div>");

treeBuffer.append("<div id='textareaStatus' style='display:none' ><table height ='100%' width='90%' border='1' cellpadding='2' cellspacing='0'>");
treeBuffer.append("<tr><td class='bg4' height='10'><font><b>&nbsp;&nbsp;Text Area Status (Press F5)</b></font></td></tr>");
treeBuffer.append("<tr><td valign='top' class='bg6'><table><tr><td><input type=text size=8 TABINDEX = 6 onFocus='fieldOnFocus = 6' name='set_caret' ><font class='ListValue'><b>&nbsp;&nbsp;Go to Position </b></font></td>");
treeBuffer.append("</tr><tr><td nowrap class='bg6'>");
treeBuffer.append("<input type=text size=8 name='current_pos' readonly><font class='ListValue'><b>&nbsp;&nbsp;Current Position</b><font></td></tr><tr><td nowrap class='bg6'>");
treeBuffer.append("<input type=text size=8 name='total_bytes' readonly><font class='ListValue'><b>&nbsp;&nbsp;Total Characters</b><font></td></tr></table></td>");
treeBuffer.append("</tr></table></div></td></tr>");


treeBuffer.append("<tr><td valign='bottom' colspan='2'><table class='bg4' border='1' cellspacing='0' cellpadding='0'><tr><td height='10' valign='bottom'>");

treeBuffer.append("<font><b>&nbsp;&nbsp;Enter the message in the text area</b></font></td></tr><tr><td>");

treeBuffer.append("<tr><td valign='top' class='bg6'>");
//treeBuffer.append("<div id='textAreaVal'><textarea  DATASRC='#xmldata' DATAFLD='data' TABINDEX = 4 onFocus='fieldOnFocus = 4' rows='"+rowN+"' cols='95'  id='XMLEntry' ");
//onClick=storeCaret(event);if(document.XMLTreeForm.raw_type[1].checked)setCursorDialog(94) onKeyUp=updateValue(this.value,'',1,event); 
//DCC Disable event for textArea: DATASRC='#xmldata' DATAFLD='data'
treeBuffer.append("<div id='textAreaVal'><textarea  TABINDEX=4 rows='"+rowN+"' cols='95'  id='XMLEntry' onClick='storeCaret(event);if(document.XMLTreeForm.raw_type[1].checked)setCursorDialog(94);' onKeyUp=updateValue(this.value,'',1,event); onFocus='fieldOnFocus = 4;' ");
//   
if(checkReadOnlyOption() || raw == "RAW_HEXA"){
	treeBuffer.append(" READONLY ");
}

treeBuffer.append(">");

if(val != null){
	treeBuffer.append(val);
}

treeBuffer.append("</textarea></div>");//
treeBuffer.append("</td></tr>");
treeBuffer.append("</table>");
treeBuffer.append("</DIV>");

if(raw == "STRING")
	document.getElementById('textareaStatus').style.display = "block";

//var xmlEntry;
try{
	//document.getElementById('treeSub0').innerHTML = treeBuffer.toString(); //tree;
	treeSub.innerHTML = treeBuffer.toString();

//	xmlEntry = document.getElementById('XMLEntry');
/*
	if(val != null){
		xmlEntry.value=val;
	}
*/
}catch(e){
	alert("DCC:"+e.message);
}
//if(document.XMLTreeForm.raw_type!=undefined )
{
	if(raw=="")
		document.XMLTreeForm.raw_type[2].checked = true;
	else
	if(raw == "RAW_TEXT")
	{
		document.XMLTreeForm.raw_type[0].checked = true;
	}
	else
	if(raw == "STRING")
	{
		document.XMLTreeForm.raw_type[0].checked = true;
		document.XMLTreeForm.raw_type[1].disabled = true;
		document.XMLTreeForm.raw_type[2].disabled = true;
	//DCC	document.getElementById('textareaStatus').style.display = "block";
	}
	else
	{
		document.XMLTreeForm.raw_type[1].checked = true;
		hexValueFlag = 1;
	}
}

//if(!checkReadOnlyOption())
//	xmlEntry.focus();
//DCC	document.getElementById('XMLEntry').focus();

}



function editNode(type)
{
	if(type == 'STRING')
	{
		var returnVal = ShowWindow('kxyEdtFr','','700px','650px',[nodeSel.firstChild.nodeValue,null,'',con,"",type,getHandle(),getBackConnid(),getQType(),getActiveQmgr(),getQueueName(),getBrowser(),readOnly,'',url,mbcsXML,'', '']);
	
		if(typeof returnVal != "undefined")
		{
			nodeSel.firstChild.nodeValue = returnVal;
			subNodes(arrayNode1,arrayNode2,arrayNode3,arrayNode4,arrayNode5,arrayNode6,1,arrayNode7);
		}
	}
}




function checkEnterTextarea(e){
	if(window.event || !e.which) // IE
	{
		key = e.keyCode; // for IE, same as window.event.keyCode
	}
	else if(e) // netscape
	{
		key = e.which;
	}
    if (key == 13){
    	e.returnValue = false;

	}

}




/**********************************************************************************************
					Print Preview Operation
***********************************************************************************************/
function printPreview(qmgr,qname){
	var tempDoc = getPrintHTML(qmgr,qname);
	var temp="";
	temp += "<br/>&nbsp;&nbsp;<img src='images/print.gif' id='print' onmouseover=document.getElementById('print').src='images/print_onclick.gif' onmouseout=document.getElementById('print').src='images/print.gif' onClick=window_onclose()>";
	temp += "&nbsp;&nbsp;&nbsp;&nbsp;<img src='images/close.gif' id='close' onmouseover=document.getElementById('close').src='images/close_onclick.gif' onmouseout=document.getElementById('close').src='images/close.gif'  onClick=window.close()></br></br>";
	temp +="<DIV id='printMsgs'' STYLE='height:580;width:700;overflow:auto' class='scrollLMsgTable'>";
	temp += tempDoc;
	temp += "</DIV>";
	
	DocumentToPrint = "<DIV id='printMsgs' class='print'>" + tempDoc + "</DIV>";
	
	ShowWindow('kxyPrint','','770px','700px',[temp,'frame6',getBrowser()]);
	//winOpen.document.getElementById('messagesPrint').innerHTML = temp;
	
	}



function printPreviewTree(obj,msg,seq,depth,qmgr,qname)
{
	var tempDoc;
	var unvalid = 0;
	var updatedXML = "";
	var updatedXMLObject;
 		 if (document.implementation && document.implementation.createDocument)
 		 {
 		   // netscape 6.x+ support


 			  updatedXMLObject = document.implementation.createDocument("","", null);
 		 }
 		 else if (window.ActiveXObject)
 		 {
 		   // ie 5.x+ support
  			  //updatedXMLObject = new ActiveXObject("Microsoft.XMLDOM");
					updatedXMLObject = new ActiveXObject("MSXML2.DOMDocument");
  		 }
  		else
 		 {
 		   M_alert(err_209);
 		   return;
 		 }
	if(document.XMLTreeForm.raw_type != null){
		updatedXML = document.XMLTreeForm.XMLEntry.value;
		if(browser == "NS"){
		     var objParser = new DOMParser();
		
			if(!document.XMLTreeForm.raw_type[2].checked)
				updatedXMLObject = objParser.parseFromString("<Body><![CDATA["+updatedXML+"]]></Body>", "text/xml");
			else{
				var temp = createXMLFromString(updatedXML);
				updatedXMLObject = objParser.parseFromString(serializeXML(temp), "text/xml");		
			}
		}
		else{
			if(!document.XMLTreeForm.raw_type[2].checked)
				updatedXMLObject.loadXML("<Body><![CDATA["+updatedXML+"]]></Body>");
			else
				updatedXMLObject.loadXML(updatedXML);
			
		}
		if(browser != "NS" && document.XMLTreeForm.raw_type[2].checked && updatedXMLObject.childNodes[0] == null)
			unvalid = 1;
			
		if(browser == "NS" && updatedXMLObject.childNodes[0] != null &&  updatedXMLObject.childNodes[0].nodeName == "parsererror")
			unvalid = 1;
		
		if(unvalid == 1)
			M_alert(err_204);

		if(unvalid == 0){
			if(document.XMLTreeForm.raw_type[2].checked){
				if(browser != "NS")
					updatedXMLObject.loadXML("<Body>"+updatedXML+"</Body>");
				else{
					var temp = createXMLFromString("<Body>"+updatedXML+"</Body>");
					updatedXMLObject = objParser.parseFromString(serializeXML(temp), "text/xml");		
				}	
			}
			tempDoc = getPrintHTMLTree(obj,msg,seq,depth,qmgr,qname,updatedXMLObject);
		}
	}
	else
		tempDoc = getPrintHTMLTree(obj,msg,seq,depth,qmgr,qname);		
	if(unvalid == 0){
		var temp="";
		temp += "<br/>&nbsp;&nbsp;<img src='images/print.gif' id='print' onmouseover=document.getElementById('print').src='images/print_onclick.gif' onmouseout=document.getElementById('print').src='images/print.gif' onClick=window_onclose()>";
		temp += "&nbsp;&nbsp;&nbsp;&nbsp;<img src='images/close.gif' id='close' onmouseover=document.getElementById('close').src='images/close_onclick.gif' onmouseout=document.getElementById('close').src='images/close.gif' onClick=window.close()></br></br>";
		temp +="<DIV id='printMsgs'' STYLE='height:580;width:700;overflow:auto' class='treeView'>";
		temp += tempDoc;
		temp += "</DIV>";
		
		DocumentToPrint = "<DIV id='printMsgs' class='print'>" + tempDoc + "</DIV>";
		
		ShowWindow('kxyPrint','','770px','700px',[temp,'frame8',getBrowser()]);
		//winOpen.document.getElementById('messagesPrint').innerHTML = temp;
	}
	
}


function showBigMessage(header,body){
	var Flag = new Array();
	var Index = new Array();
	var IndexHeader = new Array();
	var html = "";
	for(var t=0;t<header.length;t++){
		Flag[t] = 1;
		Index[t] = 0;
		IndexHeader[t] = 0;
		body[t] = body[t];
		header[t] = header[t];
	}
	var mesLen = 0;
	html += "<table border='1' cellpadding='3' cellspacing='0' class='bg1'>";
	for(var q = 0; q < header.length;q++){
		if(header[q] != undefined && body[q] != undefined){
			if(Flag[q] != 2){
				if(body[q].length > header[q].length){
	  				mesLen += body[q].length;
	  			}else{
	  				mesLen += header[q].length;
	  			}
	  		}
	  		if(Flag[q] == 2){
	  			if((body[q].length - Index[q]) > (header[q].length - IndexHeader[q]))
	  				mesLen += body[q].length - Index[q];
	  			else
	  				mesLen += header[q].length - IndexHeader[q];
	  		}
	  	}
	  		if(mesLen < 70){
	  			var tempLength = 0; 
	  			var valid = 0;
	  			if(q == header.length -1){
	  	  	    		for(var a=0;a< header.length;a++)
	  	  	    			if(header[a] != undefined && body[a] != undefined)
	  	  	    			{
	  	  	    			
	  	  	    			
	  	  	    			if(Flag[a] == 1){
	  	  	    				if(tempLength == 0)
	  	  	    					valid = 1;
	 	  	  	    			if(body[a].length > header[a].length)
	 	  	  	    				tempLength += body[a].length;
	 	  	  	    			else
	 	  	  	    				tempLength += header[a].length;
	 	  	  	    			
	 	  	  	   
	  	  	    				if(tempLength <= 70){
	  	  	    					if(a == 0 || valid == 1)
	  	  	    						html += "</tr></table><table border='1' cellpadding='3' cellspacing='0' class='bg1'><tr>";
	  	  	    					valid = 0;
	  	  	         				html += "<td class='bg2'><font class='tableValue'><b>"+header[a]+"</b></font></td>";
	  						}
	  					}	
	  	  	    			if(Flag[a] == 2){
	  						if((body[q].length - Index[q]) > (header[q].length - IndexHeader[q]))
	  							tempLength += body[q].length - Index[q];
	  						else
	  							tempLength += header[q].length - IndexHeader[q];
	  	  	         			 html += "</tr></table><table border='1' cellpadding='3' cellspacing='0' class='bg1'><tr><td class='bg2'><font class='tableValue'><b>"+header[a]+"</b></font></td>";
	  					 }
	  				}
	  				html += "</tr><tr>";
	  				var tempLength = 0; 
	  				for(var a=0;a< header.length;a++)
	  				if(header[a] != undefined && body[a] != undefined)
	  	  	    			{
	  					if(Flag[a] == 1){
	 	  	  	    			if(body[a].length > header[a].length)
	 	  	  	    				tempLength += body[a].length;
	 	  	  	    			else
	 	  	  	    				tempLength += header[a].length;
	 	  	  	    
	  	  	    				if(tempLength > 70){ 
	  	  	    					q = q-1;
	  	  	    					break;
	  	  	    				}
	  	  	    				else{
	  			 				html += "<td class='bg1'><font class='tableHeader'><b>"+body[a]+"</b></font></td>";
	  	  		 				Flag[a] = 0;
	  	  		 			}
	  	  	   			}	
	  					if(Flag[a] == 2){
	  						if((body[q].length - Index[q]) > (header[q].length - IndexHeader[q]))
	  							tempLength += body[q].length - Index[q];
	  						else
	  							tempLength += header[q].length - IndexHeader[q];
	  			 			html += "<td class='bg1' height='19'><font class='tableHeader'><b>"+body[a].substring(Index[a],body[a].length)+"</b></font></td>";
	  	  		 			Flag[a] = 0;
	  	  	   			}		  	  	   			
	  	  	   		}
	  	  	   	}
	  		}
	  		else
	  		if(mesLen> 70){
	  			var tempLength = 0;
	 		 	html += "<tr>";
	  	  	    	for(var a=0;a< header.length;a++)
	  	  	    		 if(header[a] != undefined && body[a] != undefined)
	  	  	    			{
	  	  	    		if(a == 0)
	  	  	    			html += "</tr></table><table border='1' cellpadding='3' cellspacing='0' class='bg1'><tr>";

	  	  	    		if(Flag[a] == 1 )
	  	  	    			if(body[a].length > header[a].length)
	  	  	    				tempLength += body[a].length;
	  	  	    			else
	  	  	    				tempLength += header[a].length;
	  	  	    		if(Flag[a] == 2)
	  	  	    			if(body[a].length > header[a].length)
	  	  	    				tempLength += body[a].length - Index[a] ;
	  	  	    			else
	  	  	    				tempLength += header[a].length - IndexHeader[a] ;	  	 
	  	  	    			
	  	  	    		if(Flag[a] == 1 && tempLength <= 70){
	  	  	         		 html += "<td class='bg2'><font class='tableValue'><b>"+header[a]+"</b></font></td>";
	  				 }
	  			
	  	  	    		if(Flag[a] == 1 && tempLength > 70){
	  	  	         		 html += "<td class='bg2'><font class='tableValue'><b>"+header[a]+"</b></font></td>";
	  	  	         		 break;
	  				 }
	  
	  				 if(Flag[a] == 2 && tempLength <= 70){
					 	  	html += "<td class='bg2'><font class='tableValue'><b>"+header[a].substring(IndexHeader[a],header[a].length)+"</b></font></td>";
		
		
	  				 }
	  				 if(Flag[a] == 2 && tempLength > 70){
	  	  	    			if(body[a].length > header[a].length)
	  	  	    				var temp = tempLength - body[a].length;
	  	  	    			else
	  	  	    				var temp = tempLength - header[a].length;
	
	  				 	  var excessLen = temp + header[a].length - 70;

					 	  html += "<td class='bg2'><font class='tableValue'><b>"+header[a].substring(IndexHeader[a],header[a].length-excessLen)+"...</b></font></td>";
					 	  
					 	  if(excessLen > 0)
	  	  	    			  	IndexHeader[a] = header[a].length-excessLen; 
					 	  break;
	  				 }
	  			}
	  			html += "</tr>";
	  			html += "<tr>";
	  			tempLength = 0;
	  	  	    	for(var a=0;a<header.length;a++)
	  	  	    		if(header[a] != undefined && body[a] != undefined)
	  	  	    		{

	  	  	    		if(Flag[a] == 1 ){
	  	  	    			if(body[a].length > header[a].length)
	  	  	    				tempLength += body[a].length;
	  	  	    			else
	  	  	    				tempLength += header[a].length;
	  	  	    		}
	  	  	    		
	  	  	    		if(Flag[a] == 2){
	  	  	    			if(body[a].length > header[a].length)
	  	  	    				tempLength += body[a].length - Index[a] ;
	  	  	    			else
	  	  	    				tempLength += header[a].length - Index[a] ;
	  	  	    			
	  	  	    		}	  	  	    		
	  	  	    		if(Flag[a] == 1 && tempLength <= 70){
	  	  	         		 html += "<td class='bg1'><font class='tableHeader'><b>"+body[a]+"</b></font></td>";
	  	  	         		 Flag[a] = 0;
	  	  	         		 //alert(body[a]+"   "+Flag[a]);
	  				 }
	  				 else
	  				 if(Flag[a] == 1 && tempLength > 70){
	  	  	    			if(body[a].length > header[a].length)
	  	  	    				var temp = tempLength - body[a].length;
	  	  	    			else
	  	  	    				var temp = tempLength - header[a].length;
	
	  				 	 var excessLen = temp + body[a].length - 70;

					 	  html += "<td class='bg1'><font class='tableHeader'><b>"+body[a].substring(0,body[a].length-excessLen)+"...</b></font></td>";
					 	  Flag[a] = 2;
	  	  	    			  if(excessLen > 0)
	  	  	    				Index[a] = body[a].length-excessLen;
		 	  
					 	  mesLen = 0;
					 	  q = q-1;
					 	  break;
					 	 
					 	  					 	  
	  				 }
	  				 else
	  				 if(Flag[a] == 2 && tempLength <= 70){
					 	  html += "<td class='bg1'><font class='tableHeader'><b>"+body[a].substring(Index[a],body[a].length)+"</b></font></td>";
					 	  Flag[a] = 0;					 	  
	  				 }
	  				 else
	  				 if(Flag[a] == 2 && tempLength > 70){
	  	  	    			if(body[a].length > header[a].length)
	  	  	    				var temp = tempLength - body[a].length;
	  	  	    			else
	  	  	    				var temp = tempLength - header[a].length;
	
	  				 	 var excessLen = temp + body[a].length - 70;

					 	  html += "<td class='bg1'><font class='tableHeader'><b>"+body[a].substring(Index[a],body[a].length-excessLen)+"...</b></font></td>";
					 	  Flag[a] = 2;		
	  	  	    			  if(excessLen > 0)
	  	  	    				Index[a] = body[a].length-excessLen;

					 	  
					 	  mesLen = 0;
					 	  q = q-1;
					 	  break;
					 	  
	  				 }
	  			}
	  	  	   	html += "</tr>";
	  
	 		 }
	 		 else
	 		 if(mesLen == 70){
	 		 	html += "<tr>";
	  	  	    	for(var a=0;a<=q;a++){
	  	  	    		if(a == 0)
	  	  	    			html += "</tr></table><table border='1' cellpadding='3' cellspacing='0' class='bg1'><tr>";
	  	  	    		if(Flag[a] == 1){
	  	  	         		 html += "<td class='bg2'><font class='tableValue'><b>"+header[a]+"</b></font></td>";
	  				 }
	  			}
	  			html += "</tr>";
	  			html += "<tr>";
	  			for(var a=0;a<=q;a++){
	  				if(Flag[a] == 1){
	  			 		html += "<td class='bg1'><font class='tableHeader'><b>"+body[a]+"</b></font></td>";
	  	  		 		Flag[a] = 0;
	  	  	   		}	
	  	  	   	}
	  	  	   	html += "</tr>";
	  	  		mesLen = 0;
	  		}

	  	
	 }
	html += "</table></br></br>";
	return html;

}


/**********************************************************************************************
					Print Operation
***********************************************************************************************/

function printOperation(qmgr,qname){
	
	parent.frame6.document.getElementById('messagesPrint').innerHTML = getPrintHTML(qmgr,qname);
	parent.frame6.focus();
	parent.frame6.print();
	
}


function printOperationTree(obj,msg,seq,depth,qmgr,qname){
	var tempDoc;
	var updatedXML = "";
	var updatedXMLObject;
 		 if (document.implementation && document.implementation.createDocument)
 		 {
 		   // netscape 6.x+ support


 			  updatedXMLObject = document.implementation.createDocument("","", null);
 		 }
 		 else if (window.ActiveXObject)
 		 {
 		   // ie 5.x+ support
  			  //updatedXMLObject = new ActiveXObject("Microsoft.XMLDOM");
  			  updatedXMLObject = new ActiveXObject("MSXML2.DOMDocument");

  		 }
  		else
 		 {
 		   M_alert(err_209);
 		   return;
 		 }
 	var unvalid = 0;
 	if(document.XMLTreeForm.raw_type != null){
 		updatedXML = document.XMLTreeForm.XMLEntry.value;
 		
 		if(browser == "NS"){
 			if(!document.XMLTreeForm.raw_type[2].checked)
 				updatedXMLObject = createXMLFromString("<Body><![CDATA["+updatedXML+"]]></Body>");
 			else
 				updatedXMLObject = createXMLFromString("<Body>"+updatedXML+"</Body>");
 			if(document.XMLTreeForm.raw_type[2].checked && updatedXMLObject.childNodes[0] == null){
 				unvalid = 1;
 				M_alert(err_204);
 			} 		
 		}
 		else{
 			if(!document.XMLTreeForm.raw_type[2].checked)
 				updatedXMLObject.loadXML("<Body><![CDATA["+updatedXML+"]]></Body>");
 			else
 				updatedXMLObject.loadXML("<Body>"+updatedXML+"</Body>");
 			if(document.XMLTreeForm.raw_type[2].checked && updatedXMLObject.childNodes[0] == null){
 				unvalid = 1;
 				M_alert(err_204);
 			}
 		}
 		
 		if(unvalid == 0)
 			tempDoc = getPrintHTMLTree(obj,msg,seq,depth,qmgr,qname,updatedXMLObject);
 	}
 	else
		tempDoc = getPrintHTMLTree(obj,msg,seq,depth,qmgr,qname);

	if(unvalid == 0 && parent.frame8 != null ){
		parent.frame8.document.getElementById('messagesPrint').innerHTML = tempDoc;
		parent.frame8.focus();
		parent.frame8.print();
	}
	else
	if(unvalid == 0 && parent.frame6 != null){
		parent.frame6.document.getElementById('messagesPrint').innerHTML=  tempDoc;
		parent.frame6.focus();
		parent.frame6.print();
	}
	else
	if(unvalid == 0 && parent.frame10 != null){
		parent.frame10.document.getElementById('messagesPrint').innerHTML=  DocumentToPrint;
		parent.frame10.focus();
		parent.frame10.print();
	}
}


function getPrintHTML(qmgr,qname){
	var temp="";

	temp += "<table width='100%' border='0' cellpadding='3' cellspacing='0' class='bg4'>";
	temp += "<tr><td class='bg1'><font><b>Queue Manager: &nbsp;&nbsp;"+qmgr+"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Queue: &nbsp;&nbsp;"+qname+"</b><br/></td></tr>";
	
	var countM;

	if(countSelectedM == 0)
		countM = mesLength;
	else
	{
		var ids = getSelectedMsg();
		countM  = countSelectedM;
	}
	for(var m = 0; m < countM; m++)
	{
		if(countSelectedM == 0)
			messages = m;	
		else
			messages = selectedMsgNos[m];

		var messageLength = 0;
		var availLength = 600;
		tagHeading = new Array();
		tagValue = new Array();
		tagHeadingBody = new Array();
		tagValueBody = new Array();

		if(getBrowser() == "NS")
			getMessageValuesNS(current_peek,messages)
		else
			getMessageValues(current_peek.childNodes[1].childNodes[1].childNodes[messages],messages);
	
		messageLength = 0;
		var msgNo;
		for(var i=0;i<tagHeading.length;i++){
			if(tagHeading[i] == 'MessageSequenceNumber')
				msgNo = tagValue[i];
		}
		if(displayHeader != 'true')
		for(var i=0;i<tagHeadingBody.length;i++){
                       if(tagHeadingBody[i]!= undefined && tagValueBody[i]!= undefined)
			if(rtrim(ltrim(tagHeadingBody[i])).length > rtrim(ltrim(tagValueBody[i])).length){
				messageLength += rtrim(ltrim(tagHeadingBody[i])).length;
			}else{
				messageLength += rtrim(ltrim(tagValueBody[i])).length;
			}
		}	
		temp += "<tr class='treeView'><td><font class=Attribute><b>Message Number:"+msgNo + "&nbsp;&nbsp;&nbsp;&nbsp; Total Messages:"+messageDepth+"</b></font></td></tr><tr><td><br/>";
		
		if(messageLength > 70 || displayHeader == 'true')
		{
			if(displayHeader != 'true')
				temp += showBigMessage(tagHeadingBody,tagValueBody);
			else
			{
				temp += showBigMessage(tagHeading,tagValue);
				temp += showBigMessage(tagHeadingBody,tagValueBody);
			}
		}
		else{

		temp += "<table border='1' cellpadding='3' cellspacing='0' class=bg3>";
		temp += "<tr>";
		

		for(var q = 0; q < tagHeadingBody.length;q++)
		{
			if(tagHeadingBody[q] != undefined)
					temp += "<td class='bg2'><font class='tableValue'><b>"+tagHeadingBody[q]+"</b></font>";		
		}
		temp += "</tr>";
		temp += "<tr >";
		
		for(var q = 0; q < tagValue.length;q++){
		if(tagValue[q] != undefined && displayHeader == 'true' && tagHeading[q] != 'MessageSequenceNumber' && tagHeading[q] != 'ConnId' && tagHeading[q] != 'KXY_TYPE' && tagHeading[q] != 'QueueDepth')
			temp += "<td class='bg2' ><font class='tableValue'><b>"+tagValue[q]+"</b></font></td>";
		
		}

		for(var q = 0; q < tagValueBody.length;q++){
		messageLength = 0;
		var tempValue = tagValueBody[q];

		if(tagValueBody[q] != undefined)
		{
			var temp1 = checkSpecialChars(tagValueBody[q]);
			temp += "<td class='bg1' style='height:19'><font class='tableHeader'><b>"+temp1+"</b></font></td>";
		}
					var tempHeading = tagHeadingBody[q].length;
					var tempValue = tagValueBody[q].length;
					if(tempHeading > tempValue)
						messageLength = tempHeading;
					else
						messageLength = tempValue;
					
					if(messageLength > 70)
						temp += "</tr><tr>";		
		}
		temp += "</tr>";
		temp += "</table></br></br>";
	   }
	}
	temp += "</td></tr></table>";
	return temp;
}


var printIteration;

function getPrintHTMLTree(nodeValRoot,msg,seq,depth,qmgr,qname,bodyObj)
{
	printIteration = 0;

	if(getBrowser() == "NS"){
		if(depth == 0)
			var nodeVal = nodeValRoot.childNodes[0].childNodes[1].childNodes[msg];
		else
			var nodeVal = nodeValRoot.childNodes[1].childNodes[3].childNodes[msg];
	}
	else{
		if(partialTag && partialTag == "Yes")
			var nodeVal = nodeValRoot.childNodes[1].childNodes[1].childNodes[0];
		else
			var nodeVal = nodeValRoot.childNodes[1].childNodes[1].childNodes[seq];
	}
	var tree="";
	tree += "<table width='100%' border='0' cellpadding='3' cellspacing='0' >";
	tree += "<tr class='bg1'><td><font><b>Queue Manager: &nbsp;&nbsp;"+qmgr+"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Queue: &nbsp;&nbsp;"+qname+"</b><br/></td></tr>";
	tree +="<tr class='bg4'><td><font><b>Message Number: &nbsp;&nbsp;"+msg+"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Total Messages: &nbsp;&nbsp;"+depth+"</b></font></td></tr><tr><td>";
	tree += "<br/><br/>";

	    if(nodeVal.childNodes.length != 0)

		tree += "<img src='images/bullet3.gif'>&nbsp;&nbsp;<font class='dark'><b>" + nodeVal.nodeName + "</b></font>";

	    else
		tree += "<img src='images/bullet3.gif'><font class='dark'><b>" + nodeVal.nodeName + "</b></font>";
	
////////////////////////////////////////////////////////////////////////////////////////////////////
	if(browser == "NS")
		tree += "<br/>";
		
	for(var i=0; i<nodeVal.childNodes.length;i++){
	   if(nodeVal.childNodes[i].nodeName != "#text")
	  	if(nodeVal.childNodes[i].nodeName == "Body" && bodyObj != null){
	  		tree += displayChildTree(bodyObj.childNodes[0]);
	  	}else{
			tree += displayChildTree(nodeVal.childNodes[i]);
		}
	}

//////////////////////////////////////////////////////////////////////////////////////////////////////

	tree += "</td></tr>";
	tree += "</table>";
	return tree;
}


var z = new Array();
var cIter = 0;

function displayChildTree(nodeVal){
cIter++;
printIteration++;

var tree = "";
if(nodeVal.nodeName != "#text")
if(nodeVal.nodeName != "MessageSequenceNumber" && nodeVal.nodeName != "KXY_TYPE"  && nodeVal.nodeName != "QueueDepth" && nodeVal.nodeName != "ConnId"){
	if(browser != "NS" || nodeVal.parentNode.nodeName == "Body")
		tree += '<br/>';
	for(var p=0; p<printIteration; p++)
		tree += '<img src="images/white.gif" />';
		
	tree += '<img src="images/bullet3.gif"><font class="dark"><b>' + nodeVal.nodeName + '</b></font>';

  	if(nodeVal.childNodes.length == 1 && (nodeVal.firstChild.nodeType == 3 || nodeVal.firstChild.nodeType == 4)){

  		tree += "&nbsp;&nbsp;&nbsp;&nbsp;<font class='Attribute'>";
  		if(nodeVal.firstChild.nodeValue.length > 50){
  			var temp = nodeVal.firstChild.nodeValue;
  			for (var q = 0; q <temp.length; q=q+50)
  			{
  				tree += "<br/>";
  				for(var p=0; p<printIteration; p++)
					tree += '<img src="images/white.gif" />';
				tree += temp.substring(q, q+50);
  			}

    		}
  		else
  			tree += checkSpecialChars(nodeVal.firstChild.nodeValue) + "</font>";

 	 }
	else{
		nodeVal = nodeVal.childNodes;

		for(z[cIter] = 0; z[cIter] < nodeVal.length; z[cIter]++){
		   if(nodeVal[z[cIter]].nodeName != "MessageSequenceNumber" && nodeVal[z[cIter]].nodeName != "KXY_TYPE"  && nodeVal[z[cIter]].nodeName != "QueueDepth" && nodeVal[z[cIter]].nodeName != "ConnId")
		     if(nodeVal[z[cIter]].nodeName != "#text"){	
			if(nodeVal[z[cIter]].childNodes.length != 0)
			{
				if(browser == "NS")
					tree += "<br/>";
				tree += displayChildTree(nodeVal[z[cIter]]);
				cIter--;
			}
			else{
				if(browser != "NS")
					tree += '<br/>';
				for(var j=0; j<printIteration; j++)
					tree += '<img src="images/white.gif" />';
				
				tree += '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src="images/bullet3.gif"><font class="dark"><b>' + nodeVal[z[cIter]].nodeName + '</b></font>';
				
			}
			if(nodeVal[z[cIter]].attributes != null && nodeVal[z[cIter]].attributes.length != 0)
			{
						for(var attributes=0; attributes< nodeVal[z[cIter]].attributes.length;attributes++)
						{
							if(nodeVal[z[cIter]].attributes[attributes].nodeName != "maxCard" && nodeVal[z[cIter]].attributes[attributes].nodeName != "maxLen" && nodeVal[z[cIter]].attributes[attributes].nodeName != "minCard" && nodeVal[z[cIter]].attributes[attributes].nodeName != "minLen" && nodeVal[z[cIter]].attributes[attributes].nodeName != "kxyType")
							{
								tree += "<font class='Attribute'><b>&nbsp;&nbsp;"+nodeVal[z[cIter]].attributes[attributes].nodeName+" = </b></font>";
								tree += "<font class='Attribute'><b>"+checkQuotes(nodeVal[z[cIter]].attributes.item(attributes).nodeValue) +"&nbsp;&nbsp;</b></font>";
							}
						}
	    		}
		     }
		     else{
		     	tree += '</br>';
			for(var j=0; j<printIteration; j++)
				tree += '<img src="images/white.gif" />';
			tree += '&nbsp;&nbsp;&nbsp;&nbsp;<font class="Attribute"><b>';
			var val = rtrim(ltrim(nodeVal[z[cIter]].nodeValue));
			if(val.length > 50){
  		  		var col = 80;
  				var row = val.length/col + 1;

  				tree += "<br/><textarea rows="+row+" cols=80 readonly='yes'>" + val + "</textarea></b></font>";
  			}
  			else
  				tree += val + '</b></font>';
							
		     }
		}
	}
}

	printIteration--;
	return tree;

}

/**********************************************************************************************
The function getMessageValues is called by generatetable function which stores the values of all 
the tag names and values for those tags in arrays tagHeading, tagValue, tagHeadingBody and
tagValueBody. It takes following argument:
node		: is the XML DOM object for the XML that carries the details of the messages in
		a Queue.
***********************************************************************************************/
function getMessageValuesNS(node,messageNo){
currentI = 0;

var messageIndex = messageNo * 2 + 1;

var nodeHeader = eval("node.childNodes[1].childNodes[3].childNodes["+messageIndex+"].childNodes[1].childNodes");
var nodeBody = eval("node.childNodes[1].childNodes[3].childNodes["+messageIndex+"].childNodes[3].childNodes");

var counter = messageNo + 1;
var countHeader = count("//Response/Body/Message["+counter+"]/Header/descendant::*",node);

counter = 0;
for(var i=1; i< nodeHeader.length; i=i+2){
	if(nodeHeader[i].childNodes.length != 0){
		tagHeading[counter] = nodeHeader[i].nodeName;
		tagValue[counter] = nodeHeader[i].childNodes[0].nodeValue;
		counter++;
	}
}

for(var i=0; i< nodeBody.length; i++){
	if(nodeBody[i].childNodes.length != 0){
		for(var q=0; q < nodeBody[i].childNodes.length; q++){
			if(nodeBody[i].childNodes.length > 1)
				getChildNodesNS(nodeBody[i].childNodes[q]);	
			else{
				tagHeadingBody[currentI] = nodeBody[i].nodeName;
				var temp = nodeBody[i].firstChild.nodeValue;
				if(temp == "")
					temp = nodeBody[i].firstChild.innerHTML;
				tagValueBody[currentI] = temp;
				currentI += 1;
			}		
		}
	}

}

}

/**********************************************************************************************
The function getChildNodes is called if the body of a message has tags whose format is not 
linear. It takes following argument:
nodeParent	: is the XML DOM object for the XML that carries the details of the body of the 
		messages in a Queue.
***********************************************************************************************/
function getChildNodesNS(nodeParent){
	var nodeChild = nodeParent.childNodes;
	if(nodeChild.length != 1){
		for(var p=0; p < nodeChild.length; p++)
			getChildNodesNS(nodeChild[p]);
	}
	else{
		tagHeadingBody[currentI] = nodeParent.nodeName;
		var temp = nodeParent.firstChild.nodeValue;
		if(temp == "")
			temp = nodeParent.firstChild.innerHTML;
		tagValueBody[currentI] = temp;
		currentI += 1;					
	}
}



function getMessageValues(node,message){
currentI = 0;
var nodeHeader = node.childNodes[0].firstChild.childNodes;
var nodeBody = node.childNodes[1].childNodes;

for(var i=0; i< nodeHeader.length; i++){
	if(nodeHeader[i].childNodes.length != 0){
		tagHeading[i] = nodeHeader[i].nodeName;
		tagValue[i] = nodeHeader[i].childNodes[0].nodeValue;
	}
}

var nodeHeader = node.childNodes[0].childNodes[1].childNodes;
for(var i=0; i< nodeHeader.length; i++){
	if(nodeHeader[i].childNodes.length != 0){
		tagHeading[tagHeading.length] = nodeHeader[i].nodeName;
		tagValue[tagValue.length] = nodeHeader[i].childNodes[0].nodeValue;
	}
}

for(var i=0; i< nodeBody.length; i++)
{
	if(nodeBody[i].childNodes.length != 0)
	{
		for(var q=0; q < nodeBody[i].childNodes.length; q++)
		{
			if(nodeBody[i].childNodes[q].nodeType != 3)
				getChildNodes(nodeBody[i].childNodes[q]);	
			else{
				
				var temp = nodeBody[i].firstChild.nodeValue;
				if(temp == "")
					temp = nodeBody[i].firstChild.innerHTML;

				tagHeadingBody[currentI] = nodeBody[i].nodeName;
				tagValueBody[currentI] = rtrim(temp);
				currentI += 1;
			}		
		}
	}
	else
	{
		tagHeadingBody[currentI] = nodeBody[i].nodeName;
		tagValueBody[currentI] = "";
		currentI += 1;	
	}
	
}

}


/**********************************************************************************************
The function getChildNodes is called if the body of a message has tags whose format is not 
linear. It takes following argument:
nodeParent	: is the XML DOM object for the XML that carries the details of the body of the 
		messages in a Queue.
***********************************************************************************************/
function getChildNodes(nodeParent){
	var nodeChild = nodeParent.childNodes;
	if(nodeChild.length != 0)
	{
		for(var p=0; p < nodeChild.length; p++){

			if(nodeChild[p].nodeType != 3)
				getChildNodes(nodeChild[p]);
			else
			{
				var temp = nodeParent.firstChild.nodeValue;
				if(temp == "")
					temp = nodeParent.firstChild.innerHTML;
				
				if(temp && ltrim(rtrim(temp)).length != 0)
				{
					tagHeadingBody[currentI] = nodeParent.nodeName;
					tagValueBody[currentI] = rtrim(temp);
					currentI += 1;	
				}
			}		
		}
	}
	else
	{
		tagHeadingBody[currentI] = nodeParent.nodeName;
		tagValueBody[currentI] = "";
		currentI += 1;	
	}
}


function selectColumnF()
{
	var idF = this.getAttribute('id');
	var temp1 = idF.indexOf("_");
	var mNo = idF.substring(7,temp1);

	var mainNode = document.getElementById('TR'+mNo);
	var temp2 = idF.substring(temp1 + 1, idF.length);
	
	var tagF = mainNode.getAttribute('format');
	var kxyF = mainNode.getAttribute('kxyType');
	selectedFmt = mainNode.getAttribute('fmt');
	selectedpFmt = mainNode.getAttribute('pFmt');
	
	if(kxyF == "STANDALONE" && tagF!= "Stream")
		var nameF = temp2;
	else
	{
		var indexF = temp2.substring(0,temp2.indexOf("_"));
		var nameF = temp2.substring(temp2.indexOf("_")+1,temp2.length);
	}

	if(kxyF == "STANDALONE" && tagF!= "Stream")
	{
		var colF = this.name;
	}
	else
		var colF = nameF;

	selectCol(nameF,idF,tagF,kxyF,indexF,colF);
}




function getMessageBody(new7,new5,newTDCell,newTDCell1)
{
	var theDoc = document;	
	var nodeParent = bodyNode;
	var node_Child = nodeParent.childNodes;
	var path = pathM;
	var messages = messagesM;
	var currentIndex = currentIndexM;
	var max = maxM;
	
	if(indexMsg >= currentIndex)
		var setFlag = 0;
	else
		var setFlag = 1;

	 if(kxy_type == "STANDALONE" &&  temptag != "Map" && temptag != "Stream")
	 {
		if(path == null)
			path = "";
		var XMLIndex = new Array();
	 }
	 if(node_Child.length == 0)
	 {
		indexMsg++;
		if(setFlag == 0)
		{
			var new8 = newTDCell.cloneNode(true);
			new8.onclick = selectColumnF;
			var node_name = nodeParent.nodeName;
			  if(kxy_type == "STANDALONE" &&  temptag == "Map")
				new8.id="tdHeadB"+messages+"_"+node_name;
			  else
			  if(kxy_type == "STANDALONE" && temptag != "Stream")
			  {
				new8.id="tdHeadB"+messages+"_"+path;
				new8.name = node_name;
			}
			else
				new8.id="tdHeadB"+messages+"_"+indexMsg+"_"+node_name;

			new8.firstChild.nodeValue = node_name;
			new7.appendChild(new8);

			var new6 = newTDCell1.cloneNode(true);
			new6.className = 'bgHeader_noData';
			if(kxy_type == "STANDALONE" && temptag == "Map")
				new6.id="div_"+conID+"_"+node_name;
			else
			if(kxy_type == "STANDALONE" && temptag != "Stream")
			{
				new6.id="div_"+conID+"_"+path;
			}
			else
				new6.id="div_"+conID+"_"+indexMsg;

			new6.onclick = captureEvent;
			new5.appendChild(new6);
		}
	 }
	 else
	 {
	 	 var prevID = "";
		 for(var p=0; p < node_Child.length; p++)
		 {
		 	
			if(indexMsg - currentIndex == max)
			{
				currentIndex = indexMsg;
				displaySymbol(currentIndex,new5);
				indexMsg++;
				break;
			}
			if(indexMsg - currentIndex > max)
				break;
			
			  var temp_type = node_Child[p].nodeType;
			  if(temp_type == 3 || temp_type == 4 || temp_type == 8)
			  {
				var validM = 1;
				var tempVal = node_Child[p].nodeValue;

				indexMsg++;

				if(kxy_type == "STANDALONE" &&  temptag != "Map" && temptag != "Stream" && rtrim(ltrim(tempVal)).length == 0 && nodeParent.childNodes.length != 1)
					indexMsg--;
				else
				if(setFlag == 0)
				{
					if(kxy_type == "STANDALONE" &&  temptag != "Map" && temptag != "Stream")
					{
						var idM = "tdHeadB"+messages+"_"+ path;

						if(prevID == idM)
						{						
							var temp = new5.lastChild.firstChild.nodeValue;
							if(node_Child[p].nodeType != 8)
								temp += tempVal;
							new5.lastChild.firstChild.nodeValue = temp;
							validM = 0;
						}
					}
					if(validM == 1)
					{
					  var new8 = newTDCell.cloneNode(true);
					  new8.onclick = selectColumnF;
					  var node_name = nodeParent.nodeName;

					  if(kxy_type == "STANDALONE" &&  temptag == "Map")
						new8.id="tdHeadB"+messages+"_"+node_name;
					  else
					  if(kxy_type == "STANDALONE" && temptag != "Stream")
					  {
						prevID = "tdHeadB"+messages+"_"+ path;

						new8.id=prevID;
						new8.name=node_name;
					  }
					  else
						new8.id="tdHeadB"+messages+"_"+indexMsg+"_"+node_name;

					 new8.firstChild.nodeValue = node_name;
					 new7.appendChild(new8);
					 
					 var new6 = newTDCell1.cloneNode(true);
					 new6.onclick = captureEvent;
					 if(kxy_type == "STANDALONE" && temptag == "Map")
						new6.id="div_"+conID+"_"+node_name;
					 else
					 if(kxy_type == "STANDALONE" && temptag != "Stream")
					 {
						new6.id="div_"+conID+"_"+path;
					}
					 else
						new6.id="div_"+conID+"_"+indexMsg;

					 if(temp_type == 8)
						 new6.appendChild(theDoc.createTextNode(" "));
					 else
						 new6.firstChild.nodeValue = tempVal;	
					 new5.appendChild(new6);
				 }
				 else
					indexMsg --;
			}
		   }
		   else
		   {
			if(kxy_type == "STANDALONE" &&  temptag != "Map" && temptag!= "Stream")
			{
				var child_name = node_Child[p].nodeName;

				if(XMLIndex[child_name] == null)
					XMLIndex[child_name] = 0;
				else
					XMLIndex[child_name] += 1;
				if(path == "")
					var XMLPath = path + child_name+"["+XMLIndex[child_name]+"]";
				else
					var XMLPath = path + "."+child_name+"["+XMLIndex[child_name]+"]";
			}
			bodyNode = node_Child[p];
			pathM = XMLPath;
			currentIndexM = currentIndex;
			getMessageBody(new7,new5,newTDCell,newTDCell1);
		   }
		} 
     }
}

function displaySymbol(currentIndex,new5)
{
	var newTD = document.createElement("td");
	var newTD1 = document.createElement("img");
	newTD.id='TABLE'+conID;
	newTD1.setAttribute("mNo",messagesM);
	newTD1.setAttribute("currentIndex",currentIndex);

	newTD1.src='images/nextCol3.gif';
	newTD1.onmouseover=changeImage;
	newTD1.onmouseout=changeImageBack;
	if(browser == "NS")
		newTD1.height='13';
	else
		newTD1.height='14';

	newTD1.onclick=displayXMLNext;
	newTD.appendChild(newTD1);
	new5.appendChild(newTD);
}



function changeImage()
{
	this.src = 'images/nextCol4.gif';
	if(browser == "NS")
		this.height='13';
}


function changeImageBack()
{
	this.src = 'images/nextCol3.gif';
	if(browser == "NS")
		this.height='13';
}

function displayXMLNext()
{
	var theDoc = document;
	var newTDCell1 = theDoc.createElement("TD");
	newTDCell1.className = 'bgTable';
	newTDCell1.appendChild(theDoc.createTextNode(" ") );
	
	var newTDCell2 = newTDCell1.cloneNode(true);
	newTDCell2.className = 'bgHeader';
	newTDCell2.appendChild(theDoc.createTextNode(" ") );
	
	messagesM = this.getAttribute("mNo");
	var temp = document.getElementById('TR'+messagesM);
	conID = temp.value;
	kxy_type = temp.getAttribute("kxyType");
	temptag = temp.getAttribute('format');
	pathM = "";

	currentIndexM = this.getAttribute("currentIndex");
	
	indexMsg = 0;
	var tab = document.getElementById("TR2_"+conID);

	var imageTab = document.getElementById("TABLE"+ conID);

	tab.removeChild(imageTab);
	new7 = document.getElementById("TR1_"+conID);
	new5 = document.getElementById("TR2_"+conID);

	bodyNode = getXMLTag("/Response/Body/Message["+messagesM+"]/Body",current_peek).cloneNode("true");
	maxM = 50;
	getMessageBody(new7,new5,newTDCell1,newTDCell2);
		
	if(colSelected == 1)
		checkColumnSelection(t_colName,t_format,t_kxyType,t_index,t_column);
	
	var aux = 'TABLE'+conID;
	var imageFlag = 0;
	
	if(document.getElementById(aux) == null)
	{
	
		tab.appendChild(imageTab);
		imageFlag = 1;
	}
  	if(document.getElementById(aux) != null)
  	{
  		var point=getAnchorPosition(aux,'msg');  // get the position of the arrow
	
  		var currpointx=document.getElementById("divM").scrollLeft;
  		var positionx;
  		if (point)
			positionx=parseInt(point.x);
  	  	else
			positionx=0;
		var temp = parseInt(currpointx)+ widthScreen;

 		if (positionx > temp)
  		{
			var messT=document.getElementById("divM");
  			if (messT)
				messT.scrollLeft=parseInt(positionx) - widthScreen + 100;
  		}
  	}
  	if(imageFlag == 1)
  	{
  		tab.removeChild(imageTab);
  	}
}



function checkColDisplay(conn)
{
var imageTab = document.getElementById("TABLE"+ conn);
if(imageTab != null)
{
	var node = imageTab.firstChild;
	pathM = node.getAttribute("path");
	conID = conn;
	messagesM = node.getAttribute("mNo");
	var temp = document.getElementById('TR'+messagesM);
	kxy_type = temp.getAttribute("kxyType");
	temptag = temp.getAttribute('format');
	currentIndexM = node.getAttribute("currentIndex");	
	indexMsg = 0;
	maxM = 50;
	var tab = document.getElementById("TR2_"+conn);
	
	tab.removeChild(imageTab);
	new7 = document.getElementById("TR1_"+conn);
	new5 = tab;
	
	var theDoc = document;
	var newTDCell1 = theDoc.createElement("TD");
	newTDCell1.className = 'bgTable';
	newTDCell1.appendChild(theDoc.createTextNode(" ") );
	
	var newTDCell2 = newTDCell1.cloneNode(true);
	newTDCell2.className = 'bgHeader';
	newTDCell2.appendChild(theDoc.createTextNode(" ") );
	
	bodyNode = getXMLTag("/Response/Body/Message["+messagesM+"]/Body",current_peek).cloneNode("true");
	getMessageBody(new7,new5,newTDCell1,newTDCell2);
		
	checkColumnSelection(t_colName,t_format,t_kxyType,t_index,t_column);
}

}


/**********************************************************************************************
The function openXMLTree is called to open a modal dialog window in order to edit the XML of 
the body of a message of a Queue. It takes following argument:
message		: is the message number for that Queue for which the option of editing the XML 
		tree is clicked.
***********************************************************************************************/
function openXMLTree(message,conid)
{
     	var XMLPATH = "/*/*/Message[Header/KXY/ConnId="+conid+"]/Header";
     	var headerMessage;
	headerMessage = getXMLTag(XMLPATH,current_peek);
     		
     	if(browser == "NS")
     		headerMessage = headerMessage.iterateNext();
     		
	var formatPATH = "/*/*/Message/Header[KXY/ConnId="+conid+"]//format";
	var fmt=getTag(formatPATH,current_peek);

	var pformatPATH = "/*/*/Message/Header[KXY/ConnId="+conid+"]//pFormat";
	var pfmt=getTag(pformatPATH,current_peek);
	
	var XMLPATH = "/*/*/Message/Header[KXY/ConnId="+conid+"]//KXY_TYPE";	
	var kxyType=getTag(XMLPATH,current_peek);

	if(kxyType == 'STANDALONE' || kxyType == 'RAW_TEXT' || kxyType == 'RAW_HEXA' || kxyType == 'UNKNOWNFORMAT' || kxyType == 'UNKNOWNINGOREFORMAT')
	{
		metaD=null;
	}
	else
	{

		if(pfmt != null && pfmt != "")
			metaD=S_getMetaData(pfmt);
		else
			metaD=S_getMetaData(fmt);	
	}

	var valid = 1;

	if(metaD  && getTag(RETURNCODE,metaD,browser) != "Success")
	{
		M_alert(getTag(EXPL,metaD,browser),getTag(EXCEPTION,metaD,browser),getTag(CCODE,metaD,browser),getTag(RCODE,metaD,browser));
		valid = 0;
	}
	if(valid == 1)
	{
		if(QType == TYPEMQ)
			ShowWindow('kxyEdtFr','','700px','650px',[current_peek.cloneNode("true"),metaD,message,conid,"",kxyType,getHandle(),getConnid(),getQType(),getActiveQmgr(),getQueueName(),getBrowser(),readOnly,"",url,mbcsXML]);
		else
			ShowWindow('kxyEdJMF','','700px','650px',[current_peek.cloneNode("true"),metaD,message,conid,"",kxyType,getHandle(),getConnid(),getQType(),getActiveQmgr(),getQueueName(),getBrowser(),readOnly,"",url,mbcsXML]);
	}
}



/**********************************************************************************************
The function openPasteDialog is called to open a modal dialog window in order to paste the 
selected messages to the list of messages for that Queue. 
***********************************************************************************************/
function openPasteDialog()
{
	ShowWindow('kxyPaste','','400px','220px',[getBrowser()]);
}



/**********************************************************************************************
The function openLoadDialog is called to open a modal dialog window in order to load the 
messages from a file and add it to the list of messages for that Queue. 
***********************************************************************************************/
function openLoadDialog()
{
	if(readOnly)
		M_alert(err_208);
	else
		ShowWindow('kxyLoadW','','410px','265px',[getHandle(),getBackConnid(),getBrowser(),url,getQType(),disableDeleteFile]);
}



/**********************************************************************************************
The function openUnloadDialog is called to open a modal dialog window in order to unload the 
selected messages to a file. 
***********************************************************************************************/
function openUnloadDialog(){

	if(mesLength == 0)
		M_alert(err_264);
	else
		ShowWindow('kxyULoWn','','430px','450px',[getHandle(),getBackConnid(),getBrowser(),url,readOnly,enableXMLUnload]);
}





function onMouseOverImage(index){
if(index == 1)
	document.XMLTreeForm.show.src='images/expandAll_onclick.gif';
else
	document.XMLTreeForm.show.src='images/expandAll.gif';
}


//******************************************************
// added for selected columns by Ana - 11.05
//******************************************************
var t_div;
var before_word;
var word;
var after_word;
var selectedColumn;
var colSelected=0;
var t_colName;
var t_colId;
var t_format;
var t_kxyType;
var t_index;
var t_column;

function getSelectedTypekxy()
{
 return t_kxyType;
}

function getSelectedFormat()
{
 return t_format;
}

function getSelectedColumn()
// returns the id of the selected column
{
  return selectedColumn;
} 

function getSelectedColName()
// returns the name of the selected column
{
  return t_colName;
}

function getColumnName(colConn,colIndex)
// given the connid of the message and the index of the column, it returns the name of that column
{
  var aux=document.getElementById("div_"+colConn+"_"+colIndex);
  if (aux!=null)
/*	if (browser=="NS")
		return aux.getAttribute("name");
	else*/
		return aux.name;
}

function getSelectedColNo()
{

return t_index;
}

function columnOff(findWin)
{
if(t_colId == null)
{
	if(colSelected == 1)
	{
		col="tdHeadB";
		i=t_index;
		if(t_kxyType == "Header")
			highlightColH();	
		else
			highlightCol(col,COLORHEADEROFF,t_format,i,t_kxyType,t_index);	
		colSelected = 0;
		t_colName = null;
	}
	else
		select_flag = "";
}
else
{
	colSelected=1;
	if(t_kxyType == "Header")
		highlightColH();	
	else
		selectCol(t_colName,t_colId,t_format,t_kxyType,t_index,t_column,findWin);
}
	
}


function selectCol(colName,colId,format,kxyType,index,col_name,findWin)
{
if ((win!=null)&&(findWin!=1))  // user is trying to select a new column while find window open
{
	if(findReplFlag == 1)
		M_alert(err_271);
	else
		M_alert(err_272);
	return false;
}

if (colSelected==0)
{
	col=colId.substr(0,7);  // get tdHeader, without the x, y coordinate
	var temp2 = colId.substring(colId.indexOf("_") + 1, colId.length);
	i=temp2.substr(temp2.indexOf("_")+1,temp2.length);
	t_colName=colName;
	t_colId=colId;
	t_format=format;
	t_kxyType=kxyType;
	t_index=index;
	t_column = col_name;
	highlightCol(col,COLORHEADERON,format,i,kxyType,index);
	selectedColumn=colId;
	colSelected=1;
}else if (colSelected==1){
  if(t_kxyType == "Header")
  {
	highlightColH();
	selectCol(colName,colId,format,kxyType,index,col_name);
  }
  else
  if(((t_kxyType=="RAW_TEXT" || t_kxyType=="RAW_HEXA") && (kxyType=="RAW_TEXT" || kxyType=="RAW_HEXA") && t_index==index) || (t_format==format && t_kxyType==kxyType && t_index==index && t_colName == colName))
  {  // i'm in the same column that i selected before
	col=colId.substr(0,7);  // get tdHeader, without the x, y coordinate
	var temp2 = colId.substring(colId.indexOf("_") + 1, colId.length);
	i=temp2.substr(temp2.indexOf("_")+1,temp2.length);
	highlightCol(col,COLORHEADEROFF,format,i,kxyType,index);
	selectedColumn=null;
	t_colName=null;
	t_colId=null;
	t_format=null;
	t_kxyType=null;
	t_index=null;
	t_column = null;
	found=null;
	colSelected=0;}
  else{
	selectCol(t_colName,t_colId,t_format,t_kxyType,t_index,t_column);
	selectCol(colName,colId,format,kxyType,index,col_name);
   }
}
}

function highlightCol(colName,color,format,y,Type,index)
// type contains kxyType, format= pformat
{
 var name;
 var col;
var kxyType;


var oForm = document.getElementById('checkAll').form; 
var i = 0;
var el;
while (el = oForm[i++]) 
if (el.type == 'checkbox' && el.id != 'checkAll' && el.id != 'showHeader')
{
	var parentN = el.parentNode;
	var p_type = parentN.kxyType;

	if(((Type == "RAW_TEXT" || Type == "RAW_HEXA") && (p_type == "RAW_TEXT" || p_type == "RAW_HEXA")) || (parentN.format == format && p_type == Type))
 	{
 		var id = el.id;
 		var p = id.substring(8, id.length); 

		if(Type == "STANDALONE" && format!= "Stream")
			col=document.getElementById(colName+p+"_"+t_colName);
		else
			col=document.getElementById(colName+p+"_"+index+"_"+t_colName);
		
		if (col)
		{
			var valid = 1;
			if(color == "bg5" && (Type == "STANDALONE" && format != "Map" && format!= "Stream"))
			{
				var idF = col.getAttribute('id');
				var temp1 = idF.indexOf("_");
				var nameF = idF.substring(temp1 + 1, idF.length);

				if(t_colName != nameF)
					valid = 0;
			}
			if(valid == 1)
			{
				col.className=color;	
			}
		}
	}
}
}

var noreplace=false;
var currpointx=0;
var currpointy=0;

function innerTxt(strCol,value,offset)
{
var str1="";
var val="";
var str2="";

if (offset!=0)
	str1=strCol.substr(0,offset);

val=strCol.substr(offset+33,value.length);
str2=strCol.substr(parseInt(offset)+33+value.length+7,strCol.length-40-parseInt(offset)-value.length);

return str1+val+str2;
}



var select_flag = "";
var originVal = "";
function selectFind(index,xml,colName,value,mode,newvalue,fmt,kxyT)
{
var valid = 1;

var ci=getTag(XPATHCONNID,xml);
var offset=getTag(OFFSET,xml);
var str;
var messT;
if ((ci)&&(ci!=null))
{
  if(kxyT == "Header" || (kxyT == "STANDALONE" && fmt != "Stream"))
  	var aux="div_"+ci+"_"+colName;
  else
  	var aux="div_"+ci+"_"+index;

  var strCol= "";
  
 if(document.getElementById(aux) == null)
 	captureEvent();


while(document.getElementById(aux) == null)
{
	if(document.getElementById("TABLE"+ ci))
		checkColDisplay(ci);
	else
	{
		valid = 0;
		break;
	}
}

if(valid == 1)
{
 if(mode != 'replace' && select_flag != aux && document.getElementById(aux).firstChild != null && document.getElementById(aux).firstChild.nodeValue != null)
 {
 	if(select_flag != "")
 	{
 		var temp = document.getElementById(select_flag);
 		if(temp)
 		{
 			temp.innerText = "";
			if(temp.firstChild == null)
			{
   				var nodeNew = document.createTextNode("");
    				temp.appendChild(nodeNew);
    			}
    			temp.firstChild.nodeValue = originVal;
    		}
     	}

	strCol = document.getElementById(aux).firstChild.nodeValue;

	if(strCol == "")
	{
		strCol = document.getElementById(aux).innerText;
	}

 	originVal = strCol;
 }
else{
	strCol = originVal;
}

select_flag = aux;

t_div=document.getElementById(aux);

  if (mode=='replace')	
  {	
	before_word='';
	word=newvalue;
	after_word='';
        highLightStr(strCol,offset,newvalue,value,mode);
  }	
  else{
	if (noreplace==false)
	{
	  highLightStr(strCol,offset,value,null,mode);

	  var m_no = document.getElementById('imgMsg'+ci).getAttribute("mNo");
	  
	  if(browser == "NS")
	  	document.getElementById("TR"+m_no).className = "bg9_ns";
	  else
		document.getElementById("TR"+m_no).className = "bg9";
	}
}
  
  not_EventCapture=false;
	
  if (browser=="ie")
	t_div.setCapture();
  
  return 0;
}else
	return null;
}
}

function scrollup()
{
}

function captureEvent()
{
	if (t_div!=null)
	{
		if(rtrim(ltrim(originVal)).length == 0)
		{
  			t_div.innerText= "";
  			if(t_div.firstChild == null)
  			{
     				var nodeNew = document.createTextNode("");
      				t_div.appendChild(nodeNew);
    			}
    	 		t_div.firstChild.nodeValue = "    ";
  			
		}
		else
		{
   	 		t_div.innerText  = "";
  			if(t_div.firstChild == null)
  			{
     				var nodeNew = document.createTextNode("");
      				t_div.appendChild(nodeNew);
    			}
    	 		t_div.firstChild.nodeValue = originVal;
    	 	}

    	}
if (browser=="ie")
{
	if (t_div!=null)
	{
		t_div.releaseCapture();
		t_div=null;
	}
}

// good luck: add event listener for ns
}



function highLightStr(str,offset,value,oldvalue,mode)
{
 var valid = 1;

  if(t_format == "")
  {
  	str = replaceTextArea(str,'\r\n','');
   }

  before_word=str.substring(0,offset);

  if (oldvalue!=null)
	  after_word=str.substr(before_word.length+oldvalue.length,str.length);
  else{
	  after_word=str.substr(before_word.length+value.length,str.length);
	  word=str.substr(before_word.length,value.length);
  }
  
  originVal = before_word + word + after_word;


  if(originVal.length == 0)
	valid = 0;

if(t_kxyType == "Header")
{
	var invisibleV = "invisibleH";
	var blankV = "blankSpaceH";
	var strongV = "strongH";
}
else
{
	var invisibleV = "invisible";
	var blankV = "blankSpace";
	var strongV = "strong";
}

  	var t_div = document.getElementById(select_flag);
  	t_div.innerHTML = "";

  	if(valid == 0)	
  	{
		   	var nodeNew2 = document.createElement(invisibleV);
		   	t_div.appendChild(nodeNew2);
  			var nodeNew3 = document.createTextNode("a");
  			nodeNew2.appendChild(nodeNew3);   
  			t_div.appendChild(nodeNew2);
  	}
  	else
  	{

  		var nodeNew3 = document.createTextNode(before_word);
		t_div.appendChild(nodeNew3); 	 
		   
		var nodeNew2 = document.createElement(strongV);
		t_div.appendChild(nodeNew2);
		var nodeNew3 = document.createTextNode(word);
		nodeNew2.appendChild(nodeNew3); 
		
  	     	var nodeNew4 = document.createTextNode(after_word);
  	    	t_div.appendChild(nodeNew4);
       }
  
  var div=t_div;
  
  point=getAnchorPosition(select_flag,'msg');  // get the position of the string found
	
  currpointx=document.getElementById("divM").scrollLeft;
  currpointy=document.getElementById("messagesDisplay").scrollTop;
  var position;
  var positionx;
  if (point)
  {
  	if(browser == "NS")
  	{
  		var mes_seq = getTag("/Response/Body/Message/Header[KXY/ConnId="+ci+"]//MessageSequenceNumber",current_peek);
  		var diff = mes_seq - beginSequence;
  		position = point.y - 21 + diff * 47;
  	}
  	else
		position=parseInt(point.y) - 170;
	
	var temp = parseInt(offset);
	
	var multiple = parseInt(temp/1000);
	
	var offsetM = temp % 1000;
	if(temp <= 120)
		positionx=parseInt(point.x) - 50;
	else
		positionx=parseInt(point.x) + (widthScreen - 100) * temp/ 134  ;
  }
  else
  {
	position=0;
	positionx=0;
  }
  if ((position<currpointy)||(position > parseInt(currpointy)+ heightScreen - 100))	// we need to scroll
  {
	messT=document.getElementById("messagesDisplay");
	if (messT)
		messT.scrollTop=parseInt(position);
	currpointy=parseInt(position);
  }
  
  if ((positionx<currpointx) || (positionx > (parseInt(currpointx) + widthScreen - 350)))
  {
	messT=document.getElementById("divM");
  	if (messT)
		messT.scrollLeft=parseInt(positionx);
 	 currpointx=parseInt(positionx);//positionx+634;
  }
}



function contReplaceClose(doapply)
{
 if (doapply==true)
   M_apply();
 setPointerTableRefresh(null,true);
 needtoUpdate=false;
 win=null;
}


function chkColSel()
{
	checkColumnSelection(param_1,param_2,param_3,param_4,param_5);
}

function checkColumnSelection(colName,format,kxyType,index,column)
{
	if(kxyType == "Header")
	{
		highlightColH('',colName,kxyType);
	}
	else
	{
		col="tdHeadB";
		i=index;
		t_colName=colName;
		t_format=format;
		t_kxyType=kxyType;
		t_index=index;
		t_column = column;
		highlightCol(col,COLORHEADERON,format,i,kxyType,index);
		colSelected=1;
	}
	//select_flag = "";
	//originVal = "";

	if(win != null)
		win.focus();
}



//******************************************************
// added for Pending Messages
//******************************************************



function pendingMessages(index,response)
{
    if(response != null)
    {
	if(index == 1)     // -------------- Create ------------
	{
		var countCurrent = 0;
		
		if(current_peek != null)
			countCurrent = count("//Response/Body/Message",current_peek);

		if(countCurrent == 0)
			current_peek = response;
		else
		{
			var xmlNode = getXMLTag("//Message",current_peek);
			var newNode = getXMLTag("//Message",response);
			xmlNode.parentNode.appendChild(newNode);
		}
		generateTable(current_peek, displayHeader,countCurrent);
		if(colSelected == 1)
		{
			param_1 = t_colName;
			param_2 = t_format;
			param_3 = t_kxyType;
			param_4 = t_index;
			param_5 = t_column;
			param_6 = countCurrent + 1;
			setTimeout("chkColSel()", 1);
		}
		messageDepth = getTag("/Response/Header/QueueDepth",response);
	}
	else
	if(index == 2)     // -------------- Update ------------
	{	
		var theDoc = document;
		var tempM = selectedMessage;
		var oPrivateTree = theDoc.createElement("TABLE");
		var oMasterRow = theDoc.createElement("TR");
		oPrivateTree.appendChild(theDoc.createElement("TBODY"));
		oPrivateTree.firstChild.appendChild(oMasterRow);

		var oPrivateTree1 = oPrivateTree.cloneNode(true);

		var oMasterRow1 = theDoc.createElement("TR");
		oPrivateTree.firstChild.appendChild(oMasterRow1);

		var newTDCell = theDoc.createElement("TD");
		newTDCell.appendChild(theDoc.createTextNode(" ") );
		var newTDCell2 = newTDCell.cloneNode(true);

		newTDCell.className = 'bgTable';

		var newTDCell1 = theDoc.createElement("TD");
		newTDCell1.className = 'bgHeader';
		newTDCell1.appendChild(theDoc.createTextNode(" ") );

		newTDCell2.appendChild(theDoc.createElement("br"));
		var newImg = theDoc.createElement("img");
		newImg.src=CachedImage;

		newTDCell2.appendChild(newImg);

		var newC1 = theDoc.createElement("input");
		newC1.type='checkbox';
		newTDCell2.appendChild(newC1);
	
   		var mnode = getXMLTag("/Response/Body/Message",response);
		var xmlNode = getXMLTag("//Message["+tempM+"]",current_peek);

		xmlNode.parentNode.insertBefore(mnode,xmlNode);

		var temp = tempM + 1;
		xmlNode = getXMLTag("//Message["+temp+"]",current_peek);
		
		xmlNode.parentNode.removeChild(xmlNode);
		
   		mnode = getXMLTag("/Response/Body/Message["+tempM+"]",current_peek).cloneNode("true");
		bodyNode = getXMLTag("Body",mnode);
		conID =  getTag("//ConnId",mnode);

		var bodyTypeJMS = getTag("//BodyType",mnode);
		if(QType != TYPEMQ && (bodyTypeJMS == "Stream" || bodyTypeJMS == "Map"))
			temptag = bodyTypeJMS;
		else
		{
			temptag = getTag("//pFormat",mnode);
			if(rtrim(ltrim(temptag)).length == 0)
				temptag = getTag("//format",mnode);	
		}
		kxy_type = getTag("//KXY_TYPE",mnode);
		var kxyStatus = getTag("//KXY_STATUS",mnode);
		var STATUS = getTag("//STATUS",mnode);
		var mes_seq_no = getTag("//MessageSequenceNumber",mnode);
		var fmt_name="";
		if(temptag != null)
		for(var k=temptag.length;k>=1;k--){
			if(temptag.charAt(k) == ":")
			{
				fmt_name = temptag.substring(k+1,temptag.length);
				break;
			}
		}
		else
			temptag = "";
		if(fmt_name != "")
			temptag = fmt_name;
			
		var new1 = document.getElementById("TR1_"+conID);
		var new2 = document.getElementById("TR2_"+conID);

		var newParent =new1.parentNode;
		newParent.removeChild(new1);
		newParent.removeChild(new2);

		var new7 = newParent.insertRow();
		var new5 = newParent.insertRow();
		new7.id='TR1_'+conID;
		new5.id='TR2_'+conID;

		messagesM = tempM;
		maxM = 20;
		currentIndexM = 0;
		pathM = "";
		indexMsg = 0;
		
		getMessageBody(new7,new5,newTDCell,newTDCell1);
		
		var temp = document.getElementById('TR' + tempM);
		if(temp != null)
		{
				temp.className = bgR;
				temp.value=conID;
				temp.setAttribute("kxyType",kxy_type);
				temp.setAttribute("format",temptag);
		}

		var tab3 = document.getElementById('divHM');

		if (displayHeader == "true" || (displayHeader == "false" && tab3.innerHTML != ""))
		{

			var new1H = document.getElementById("TRH1_"+tempM);
			var new2H = document.getElementById("TRH2_"+tempM);

			var newParentH =new1H.parentNode;
			newParentH.removeChild(new1H);
			newParentH.removeChild(new2H);

			var new3_7 = newParentH.insertRow();
			new3_7.id = "TRH1_"+tempM;
			var new3_5 = newParentH.insertRow();
			new3_5.id = "TRH2_"+tempM;
			if(new3_5)
				showHeaders(true, tempM, mnode, conID,new3_5,new3_7);

		}


		if(colSelected == 1)
			checkColumnSelection(t_colName,t_format,t_kxyType,t_index,t_column);
		
		statusUpdateTable(current_peek);

	}
	else
	if(index == 3)     // -------------- Cut, Delete, Forward ------------
	{
		var countM = count("//Response/Body/Message",response);
		
		for(var i = 0; i<countM; i++)
		{
			var mnode = getXMLTag("/Response/Body/Message["+i+"]",response).cloneNode("true");

			conID =  getTag("//ConnId",mnode);
			
			var xmlNode = getXMLTag("//Message[Header/KXY/ConnId = "+conID+"]",current_peek);
			xmlNode.parentNode.insertBefore(mnode,xmlNode);

			xmlNode.parentNode.removeChild(xmlNode);
		}
		statusUpdateTable(current_peek);
		messageDepth = getTag("/Response/Header/QueueDepth",response);
	}
	else
	if(index == 4)     // -------------- Paste ------------
	{
		var countM = count("//Response/Body/Message",response);
		var countCurrent = 0;
		if(current_peek != null)
			countCurrent = count("//Response/Body/Message",current_peek);
		if(countCurrent == 0)
			current_peek = response;
		else
		{
			var xmlNode = getXMLTag("//Message",current_peek);
		
			for(var i = 0; i<countM; i++)
			{

				var newNode = getXMLTag("//Message[0]",response);
				xmlNode.parentNode.appendChild(newNode);
			}
		}

		generateTable(current_peek, displayHeader,countCurrent);
		if(colSelected == 1)
		{
			param_1 = t_colName;
			param_2 = t_format;
			param_3 = t_kxyType;
			param_4 = t_index;
			param_5 = t_column;
			param_6 = countCurrent;
			setTimeout("chkColSel()", 1);
		}
		messageDepth = getTag("/Response/Header/QueueDepth",response);
	}
	else     // -------------- Replace All / Replace------------
	{
		
		var countM = count("//Response/Body/Message",response);
		
		var mesRow = new Array();
		var mesRow2 = new Array();
		var mesNo = new Array();
		
		for(var q = 0; q < countM; q++)
		{
			var ret = generateTableReplace(response,q);
			mesRow[q] = ret[0];
			mesRow2[q] = ret[1];
			mesNo[q] = conID;
		}

		for(var q = 0; q < countM; q++)
		{	
			var new1 = document.getElementById('TR1_'+mesNo[q]);
			var newParent = new1.parentNode;
			newParent.removeChild(newParent.firstChild);	
			newParent.removeChild(newParent.firstChild);
			newParent.appendChild(mesRow[q])
			newParent.appendChild(mesRow2[q]);
		}

		if(index == 5 && colSelected == 1)
			checkColumnSelection(t_colName,t_format,t_kxyType,t_index,t_column);	
				
		statusUpdateTable(current_peek);
	}

	tableStatus();
	var tab3 = document.getElementById('divHM');
	if(displayHeader == "true")
		tab3.style.display = "block";
	else
		tab3.style.display = "none";
	select_flag = "";
	//originVal = "";
    }
    else
    	resetPointerTable();
}


function statusUpdateTable(response)
{
	var countM = count("//Response/Body/Message",response);
	for(var q = 0; q < countM; q++)
	{	
		if(getTag("//Response/Body/Message["+q+"]/Header/KXY/StatusFlag",response)== 1)
		{
			var STATUS = getTag("//Response/Body/Message["+q+"]/Header/KXY/STATUS",response);
			var partial = getTag("//Response/Body/Message["+q+"]/Header/KXY/Partial",response);
			var kxyStatus = getTag("//Response/Body/Message["+q+"]/Header/KXY/KXY_STATUS",response);
			
			if(rtrim(ltrim(STATUS)).length != 0)
			{
			var temp = document.getElementById('TR' + q);

			if(temp != null)
			{
				temp.className = bgR;

				var temp4 = temp.firstChild;
					
				if(partial == "Yes")
				{
					if(STATUS == "DEL" || kxyStatus != "MDR_PARSE_ERROR")
						temp.firstChild.nodeValue = "* "+ STATUS;
					else
						temp.firstChild.nodeValue = "*!"+ STATUS;		
				}
				else
					if(STATUS == "DEL" || kxyStatus != "MDR_PARSE_ERROR")
						temp.firstChild.nodeValue = STATUS;
					else
						temp.firstChild.nodeValue = "! "+ STATUS;
						
				var temp2 = document.getElementById('checkbox' + q);
				if(temp2)
				{
					temp2.setAttribute("err",1);
					temp2.checked = false;
					if(STATUS == "DEL")
					{
						var con = getTag("//Response/Body/Message["+q+"]/Header/KXY/ConnId",response);

						var temp3 = document.getElementById('imgMsg'+con);
						if(colSelected == 1)
						{
							var Type = getTag("//Response/Body/Message["+q+"]/Header/KXY/KXY_TYPE",response);
							if(QType == TYPEMQ)
								var format = getTag("//Response/Body/Message["+q+"]/Header//format",response);
							else
								var format = getTag("//Response/Body/Message["+q+"]/Header//BodyType",response);
							if(Type == "STANDALONE" && format!= "Stream")
								col=document.getElementById("tdHeadB"+q+"_"+t_colName);
							else
								col=document.getElementById("tdHeadB"+q+"_"+t_index+"_"+t_colName);

							if(col)
								col.className=COLORHEADEROFF;	
						}
							
						if(temp3)
							temp.removeChild(temp3);
						temp.removeChild(temp2);
						temp.width='35';
					}
				}	
			}
			}
		}
	}
}



function generateTableReplace(response,q)
{
	var theDoc = document;
	var newTDCell1 = theDoc.createElement("TD");
	newTDCell1.className = 'bgTable';
	newTDCell1.appendChild(theDoc.createTextNode(" ") );
	
	var newTDCell2 = newTDCell1.cloneNode(true);
	newTDCell2.className = 'bgHeader';
	newTDCell2.appendChild(theDoc.createTextNode(" ") );
	
	var mnode = getXMLTag("/Response/Body/Message["+q+"]",response).cloneNode("true")
	conID =  getTag("//ConnId",mnode);
			
	bodyNode = getXMLTag("Body",mnode);

	temptag = "";

	var bodyTypeJMS = getTag("//BodyType",mnode);
	if(QType != TYPEMQ && (bodyTypeJMS == "Stream" || bodyTypeJMS == "Map"))
		temptag = bodyTypeJMS;
	else
	{
		temptag = getTag("//pFormat",mnode);
		if(rtrim(ltrim(temptag)).length == 0)
			temptag = getTag("//format",mnode);	
	}

	kxy_type = getTag("//KXY_TYPE",mnode);
	var kxyStatus = getTag("//KXY_STATUS",mnode);
	var STATUS = getTag("//STATUS",mnode);
	var mes_seq_no = getTag("//MessageSequenceNumber",mnode);
	messagesM = document.getElementById('imgMsg'+conID).getAttribute("mNo");

	var fmt_name="";
	if(temptag != null)
	for(var k=temptag.length;k>=1;k--){
		if(temptag.charAt(k) == ":")
		{
			fmt_name = temptag.substring(k+1,temptag.length);
			break;
		}
	}
	else
		temptag = "";
	if(fmt_name != "")
		temptag = fmt_name;
	indexMsg = 0;

		
	new7 = document.createElement("tr");
	new5 = document.createElement("tr");
	new7.id='TR1_'+conID;
	new5.id='TR2_'+conID;

	maxM = 20;
	currentIndexM = 0;
	pathM = "";

	getMessageBody(new7,new5,newTDCell1,newTDCell2);

	var tab3 = document.getElementById('divHM');

	if (displayHeader == "true" || (displayHeader == "false" && tab3.innerHTML != ""))
	{
		var new1H = document.getElementById("TRH1_"+messagesM);
		var new2H = document.getElementById("TRH2_"+messagesM);

		var newParentH =new1H.parentNode;
		newParentH.removeChild(new1H);
		newParentH.removeChild(new2H);

		var new3_7 = newParentH.insertRow();
		new3_7.id = "TRH1_"+messagesM;
		var new3_5 = newParentH.insertRow();
		new3_5.id = "TRH2_"+messagesM;
		if(new3_5)
			showHeaders(true, messagesM, mnode, conID,new3_5,new3_7);
	}
	
	var xmlNode = getXMLTag("//Message[Header/KXY/ConnId = "+conID+"]",current_peek);
	var parent_N = xmlNode.parentNode;
	
	parent_N.insertBefore(mnode,xmlNode);
	parent_N.removeChild(xmlNode);
	
	return [new7, new5];
}