/*
#$Id: kxyTree.js,v 1.1.2.4 2009/08/21 08:49:32 cjj Exp $#
######################################################################

             IBM Confidential
             
             OCO Source Materials
             
             (C) Copyright IBM Corp. 2005
             
             The source code for this program is not
             published or otherwise divested of its
             trade secrets, irrespective of what has
             been deposited with the U.S Government
             Copyright Office.

######################################################################
######################################################################
# Copyright 1999-2003, Candle Corporation, a California corporation.  
# All rights reserved. International copyright secured.
#
# This material is proprietary to Candle Corporation and is not to be
# reproduced, used, or disclosed except in accordance with program
# licenses or upon written authorization of Candle Corporation.
#
#######################################################################*/
/**********************************************************************************************
 Tree.js
 ***********************************************************************************************
 Tree.js has functions that help in creating the menu tree in the 'leftColumn.htm' 
 ***********************************************************************************************
 ***********************************************************************************************/

/**********************************************************************************************
Variables --
tree		: is a string variable that contains the HTML tags in the form of string that 
		create the menu tree.
xml_client	: is an array that carries the names of all the client connections.
xml_channel	: is an array that carries the value of channels for all the client connections.
xml_host	: is an array that carries the value of all the name of the hosts for all the
		client connections.
xml_port	: is an array that carries the values of all the port numbers for all the client
		connections.
xml_connection  : is an array that carries the value of xml_channel, xml_host, xml_port for a 
		particular client connection.
array_mq	: is an array that carries the names all the Local Queue managers for MQSeries.
array_jms_name	: is an array that carries the names of all the JMS connections.
array_jms_url	: is an array that carries the urls for all teh JMS connections.
array_jms_factory: is an array taht carries the factory names for all the JMS 
***********************************************************************************************/
var tree = "";
var xml_client;
var xml_mgr;
var xml_channel;
var xml_host;
var xml_port;
var xml_ccsid;
var xml_connection = new Array();
var array_mq = new Array();
var array_jms_name;
var array_jms_url;
var array_jms_factory;
var array_jms = new Array();
var xml_pro_name;
var xml_pro_value;
var heightLeftCol;
// cjj , the adminCredentials variable controls whether the subtree button of
// the "Client Connections" tree node is enable or not.
// if it is "Yes" , the button is enable, else it is disable.
var adminCredentials;
// cjj end

// lidongq
var switchDefaultModuleQueue = false;

// IF08
var queueManagerSortByHost = true;
var xml_sort_list;

/*******************************************************************************
 * getMQDetails is the function that receives the XML DOM object from Manager
 * and extracts the name of Queue Managers for MQSeries and puts them in an
 * array array_mq.
 * 
 * Inside this function is a function call to count, that returns the number of
 * child nodes that node has whose xpath has been passed to the count function
 * as first parameter. The second parameter to be passed to this function is the
 * xml dom object in which the xpath specifies can be found.
 ******************************************************************************/
function getMQDetails(mqObj) {
	var countMQ = 0;

	countMQ = parent.count("//ResourceList/Resource", mqObj);

	if (countMQ != 0) {
		for (e = 0; e < countMQ; e++)
			array_mq[e] = parent.getTag("//ResourceList/Resource[" + e
					+ "]/Name", mqObj);
		return true;
	} else
		return false;
}

function sortByQMName(a,b){
	if (a[0] > b[0]){
		return 1 ;
	}else if (a[0] == b[0]){
		return 0 ;
	}else{
		return -1;
		
	}
}

/*******************************************************************************
 * getClientDetails is the function that receives the XML DOM object from
 * Manager and extracts the name of Client connections for MQSeries and puts
 * them in the arrays xml_client,xml_host, xml_channel,xml_port.
 ******************************************************************************/
function getClientDetails(XMLObj) {
	xml_client = new Array();
	xml_host = new Array();
	xml_channel = new Array();
	xml_port = new Array();
	xml_ccsid = new Array();
	xml_mgr = new Array();
	xml_pro_name = new Array();
	xml_pro_value = new Array();
	xml_default_module_queue = new Array();
	
	//IF08 [["QMNAME",previous_position]]
	xml_sort_list = new Array();
	
	

	var nameArray;
	var valueArray;
	var index;

	var countMQ = 0;
	countMQ = parent.count("//ClientConnections/ClientConnection", XMLObj);
	if (countMQ != 0) {
		for (e = 0; e < countMQ; e++) {
			nameArray = new Array();
			valueArray = new Array();
			index = 0;
			xml_client[e] = parent.getTag(
					"//ClientConnections/ClientConnection[" + e + "]/Name",
					XMLObj);
			xml_mgr[e] = parent.getTag("//ClientConnections/ClientConnection["
					+ e + "]/Resource", XMLObj);
			xml_host[e] = parent.getTag("//ClientConnections/ClientConnection["
					+ e + "]/Host", XMLObj);
			xml_channel[e] = parent.getTag(
					"//ClientConnections/ClientConnection[" + e + "]/Channel",
					XMLObj);
			xml_port[e] = parent.getTag("//ClientConnections/ClientConnection["
					+ e + "]/Port", XMLObj);
			xml_ccsid[e] = parent.getTag(
					"//ClientConnections/ClientConnection[" + e + "]/CCSID",
					XMLObj);
			xml_default_module_queue[e] = parent.getTag(
					"//ClientConnections/ClientConnection[" + e
							+ "]/DefaultModuleQueue", XMLObj);
			var countPro = parent.count("//ClientConnections/ClientConnection["
					+ e + "]/Properties/Property", XMLObj);
			for ( var q = 0; q < countPro; q++) {
				nameArray[index] = parent.getTag(
						"//ClientConnections/ClientConnection[" + e
								+ "]/Properties/Property[" + q + "]/Name",
						XMLObj);
				valueArray[index] = parent.getTag(
						"//ClientConnections/ClientConnection[" + e
								+ "]/Properties/Property[" + q + "]/Value",
						XMLObj);
				index = index + 1;
			}
			xml_pro_name[e] = nameArray;
			xml_pro_value[e] = valueArray;
			
			//IF08
			var displayItem = xml_mgr[e] + '$' + xml_host[e] + '$' + xml_channel[e] ;
			xml_sort_list[e] = [displayItem,e];
		}
		// cjj. get the value from XMLObj. By default , adminCredentials is
		// false
		adminCredentials = false;
		adminCredentials = (parent.getTag("//AdminCredentials", XMLObj) == "Yes");
		// cjj end
		
		//if08 
		xml_sort_list.sort(sortByQMName);

	}
	//add switch default module queue
	switchDefaultModuleQueue = (parent.getTag("//SwitchDefaultModuleQueue",
			XMLObj) == "Yes");
	

	 
    
}

/*******************************************************************************
 * getJMSDetails is the function that receives the XML DOM object from Manager
 * and extracts the details of a JMS connection and puts the name of context in
 * array_jms_name array, name of factory in array_jms_factory and value of ldap
 * url in array_jms_url.
 ******************************************************************************/
function getJMSDetails(jmsObj) {
	array_jms_name = new Array();
	array_jms_url = new Array();
	array_jms_factory = new Array();

	var countMQ = 0;
	countMQ = parent.count("//ResourceList/Resource", jmsObj);

	if (countMQ != 0) {
		for (e = 0; e < countMQ; e++) {
			array_jms_name[e] = parent.getTag("//ResourceList/Resource[" + e
					+ "]/Name", jmsObj);
			array_jms_url[e] = parent.getTag("//ResourceList/Resource[" + e
					+ "]/URL", jmsObj);
			array_jms_factory[e] = parent.getTag("//ResourceList/Resource[" + e
					+ "]/Factory", jmsObj);
		}
	}
}

/*******************************************************************************
 * The function displayDialog opens dialog window for creating new JMS or Client
 * connection. It takes following argument: dialogName : like JMS or Client or
 * createQueue etc.
 ******************************************************************************/
function displayDialog(dialogName, type) {
	if (dialogName == "kxynwJMS")
		parent.ShowWindow(dialogName, 'new', '550px', '580px', [ browser,
				parent.globalProfile ]);
	else if (dialogName == parent.CLIENTMODAL2)
		parent.ShowWindow(dialogName, 'new', '400px', '440px', [ browser ]);
	else
		parent.ShowWindow(dialogName, 'new', '400px', '380px', [ browser ]);

}

/*******************************************************************************
 * The function openUpdateJMSDialog opens dialog window for updating an existing
 * JMS connection. It takes following argument: JMSIndex : It indicates which
 * element in the array array_jms_name, array_jms_url, array_jms_factory to
 * update for a JMS connection.
 ******************************************************************************/
function openUpdateJMSDialog(JMSIndex) {
	var params = new Array();
	params[0] = array_jms_name[JMSIndex];
	params[1] = array_jms_url[JMSIndex];
	params[2] = array_jms_factory[JMSIndex];
	params[3] = browser;
	params[4] = parent.globalProfile;
	if (browser == "NS")
		params[5] = parseInt(JMSIndex) + 1;
	else
		params[5] = JMSIndex;

	parent.ShowWindow('kxyupJMS', 'update', '550px', '580px', params);
}

/*******************************************************************************
 * The function openUpdateClientDialog opens dialog window for updating an
 * existing JMS connection. It takes following argument: ClientIndex : It
 * indicates which element in the array xml_client, xml_host,xml_channel,
 * xml_port to update for a Client connection.
 ******************************************************************************/
function openUpdateClientDialog(ClientIndex) {
	var params = new Array();
	params[0] = xml_mgr[ClientIndex];
	params[1] = xml_host[ClientIndex];
	params[2] = xml_channel[ClientIndex];
	params[3] = xml_port[ClientIndex];
	params[4] = xml_ccsid[ClientIndex];
	params[5] = xml_pro_name[ClientIndex];
	params[6] = xml_pro_value[ClientIndex];
	params[7] = browser;
	params[8] = xml_client[ClientIndex];

	if (switchDefaultModuleQueue) {
		params[9] = xml_default_module_queue[ClientIndex];
		parent.ShowWindow('kxyupdC2', 'update', '400px', '440px', params);

	} else {
		parent.ShowWindow('kxyupdC', 'update', '400px', '380px', params);
	}

}

/*******************************************************************************
 * The function RemoveJMS calls the Manager.js to delete an existing JMS
 * connection. It takes following argument: index : It indicates that element in
 * the array array_jms_name at position 'index' is to be deleted from global
 * profile.
 * 
 * '2' that is passed as the third argument inside the array structure in the
 * function call to ShowWindow represents that the connection to be removed is a
 * JMS connection. Instead of '2' , '1' is passed if a Client connection is to
 * be removed.
 ******************************************************************************/
function RemoveJMS(index) {
	parent.ShowWindow('kxydelMW', '', '510px', '190px', [
			array_jms_name[index], browser, 2 ]);
}

/*******************************************************************************
 * The function RemoveClient calls the Manager.js to delete an existing Client
 * connection. It takes following argument: index : It indicates that element in
 * the array xml_client at position 'index' is to be deleted from global
 * profile.
 * 
 * '1' that is passed as the third argument inside the array structure in the
 * function call to ShowWindow represents that the connection to be removed is a
 * client connection. Instead of '1' , '2' is passed if a JMS connection is to
 * be removed.
 ******************************************************************************/
function RemoveClient(index) {
	parent.ShowWindow('kxydelMW', '', '510px', '190px', [ xml_client[index],
			browser, 1 ]);
}

function checkNameLength(name) {
	var htmlName;
	if (name.length > 15) {
		var sub = name.substring(0, 15);
		htmlName = "<acronym title='" + name + "'>" + sub + "</acronym>";
	} else
		htmlName = name;

	document.getElementById('jmsName').innerHTML = htmlName;
}

/*******************************************************************************
 * The function expandJMS expands the JMS menu tree. The arguments it takes are:
 * xml_jms : is DOM object of all JMS connectios. index : is 0 as default. It
 * becomes 1 when a JMS connection is updated ar a new JMS connection is added.
 ******************************************************************************/
function expandJMS(xml_jms, index) {
	var JMSStatus = new Array();
	getJMSDetails(xml_jms);

	divVal = '02';

	var tree2 = "";
	for (w = 0; w < array_jms_name.length; w++) {

		tree2 += "<div id='treeSub" + divVal + w + "' nameJ='"
				+ array_jms_name[w] + "'>";
		tree2 += "<img src='images/white.gif' align='absmiddle' border='0'>";
		if (document.getElementById('treeSub' + divVal + w + w) != null) {
			JMSStatus[document.getElementById('treeSub' + divVal + w)
					.getAttribute('nameJ')] = document.getElementById('treeSub'
					+ divVal + w + w).style.display;
		}
		tree2 += "<a href='#'><img id='t"
				+ divVal
				+ w
				+ w
				+ "_tree' src='images/cross_plus.gif' align='absmiddle' border='0'  onClick=expandNode('"
				+ divVal + w + w + "',1) ></a>";
		tree2 += "<img id='t"
				+ divVal
				+ w
				+ w
				+ "_folder'  src='images/foldericon.gif' align='absmiddle' border='0'>";

		tree2 += "&nbsp;&nbsp;<img src='images/msg_menu.gif' height='12' width='13' id='imgJMS"
				+ divVal
				+ w
				+ "' style='position:relative; top:2;' onMouseOut=hidePopupMenu('tree') onmousedown=parent.frame2.hidePopupMenu('');parent.frame2.frame3.hidePopupMenu('');onMouseDownHandler(event,'imgJMS"
				+ divVal
				+ w
				+ "','JMS','"
				+ w
				+ "') onClick=menuUpdateDel('imgJMS"
				+ divVal
				+ w
				+ "','JMS','"
				+ w + "') />";
		tree2 += "&nbsp;&nbsp;<a href='#' onClick=parent.setPointer('"
				+ array_jms_name[w] + "','JMS') ><font>";

		if (array_jms_name[w].length > 15) {
			var sub = array_jms_name[w].substring(0, 15);
			tree2 += "<acronym title='" + array_jms_name[w] + "'>" + sub
					+ "...</acronym>";
		} else
			tree2 += array_jms_name[w];

		tree2 += "</font></a>";

		tree2 += "<div id='treeSub" + divVal + w + w + "'  style=display:none>";

		array_jms[0] = array_jms_factory[w];
		array_jms[1] = array_jms_url[w];

		// ///////////////////////////////////////////////////////////////////////////////////////////////
		divValue = divVal + w + w;
		if (array_jms != null) {
			for (i = 0; i < array_jms.length - 1; i++) {
				if (array_jms[i] != "") {
					tree2 += "<div id='treeSub" + divValue + i + "'  >";
					tree2 += "<img src='images/white.gif' align='absmiddle' border='0'>";
					tree2 += "<img src='images/line.gif' align='absmiddle' border='0'>";
					tree2 += "<img src='images/cross.gif' align='absmiddle' border='0'>";
					tree2 += "<font>" + array_jms[i] + "</font></div>";

				}
			}
			tree2 += "<div id='treeSub" + divValue + i + "' >";

			tree2 += "<img src='images/white.gif' align='absmiddle' border='0'>";
			tree2 += "<img src='images/line.gif' align='absmiddle' border='0'>";
			tree2 += "<img src='images/corner.gif' align='absmiddle' border='0'>";

			tree2 += "<font><acronym title='" + array_jms[i]
					+ "'>URL</acronym></font></div>";

		}

		// //////////////////////////////////////////////////////////////////////////////////////////////
		tree2 += "</div>";

	}
	tree2 += "<div id='treeSub" + divVal + w + "'>";
	tree2 += "<img src='images/white.gif' align='absmiddle' border='0'>";
	tree2 += "<img src='images/corner.gif' align='absmiddle' border='0'>";
	tree2 += "<a href='#' onClick='displayAddNewJMS()' ><font>Add New JMS</font></a></div>";

	if (parent.index != 1)
		expandNode('20', 2);

	document.getElementById('treeSub20').innerHTML = tree2;

	for ( var q = 0; q < array_jms_name.length; q++) {
		if (document.getElementById('treeSub' + divVal + q) != null) {
			var temp = document.getElementById('treeSub' + divVal + q)
					.getAttribute('nameJ');
			if (JMSStatus[temp] == "block")
				expandNode(divVal + q + q, 1);
		}
	}
}

function displayAddNewJMS() {
	displayDialog(parent.JMSMODAL, parent.TYPEJMS);
}

/*******************************************************************************
 * The function expandClients expands the Client connections menu tree for
 * MQSeries. The arguments it takes are: clientsXML : is DOM object of all
 * Client connections. clientIndex : is 0 as default. It becomes 1 when a Client
 * connection is updated ar a new Client connection is added.
 ******************************************************************************/
function expandClients(clientsXML, clientIndex) {
	getClientDetails(clientsXML);
	clientConnection('101');
}

/*******************************************************************************
 * The function showClientLoginDialog opens a dialog window when a client
 * connection is clicked & displays a dialog window with login properties which
 * are:
 * 
 *  - check box named 'Credentials' (by default unchecked). - text box 'User ID' -
 * text box 'Password' - a button called "securityExit"
 * 
 * If the user will check the 'Credentials' box, he will enter values for the
 * text boxes 'User ID' and a optional 'Password'. This will overwrite actually
 * the values used at login (this might be useful as you can have some
 * credentials on the machine PEM is running and others on the machine referred
 * by the client connection). If user selects clicks 'securityExits' button, a
 * window will show up where he might define other properties for
 * 'securityExit'.
 ******************************************************************************/
function showClientLoginDialog(client) {
	parent.ShowWindow("kxyClLog", 'new', '350px', '300px', [ browser,
			parent.globalProfile, xml_client[client] ]);
}

/*******************************************************************************
 * The function clientConnection displays the various clients for MQ Series in
 * the menu tree. The values to be displayed as parameters for those clients are
 * alredy obtained by getClientDetails() function which is called by
 * expandClients() which then calls this function in order to display the
 * details of all the clients. The arguments that this function takes are:
 * divVal : is the id of the div tag where the client menu tree is to be
 * displayed.
 ******************************************************************************/
function clientConnectionByHostName(divVal) {
	var clientStatus = new Array();
	var tree2 = "";

	if (document.getElementById('treeSub101') != null)

		for (w = 0; w < xml_client.length; w++) {
			tree2 += "<div id='treeSub" + divVal + w + "' nameC='"
					+ xml_client[w] + "' >";
			if (env_type == "all" || env_type == "")
				tree2 += "<img src='images/line.gif' align='absmiddle' border='0'>";
			else
				tree2 += "<img src='images/white.gif' align='absmiddle' border='0'>";
			tree2 += "<img src='images/white.gif' align='absmiddle' border='0'>";

			if (document.getElementById('treeSub' + divVal + w + w) != null) {
				clientStatus[document.getElementById('treeSub' + divVal + w)
						.getAttribute('nameC')] = document
						.getElementById('treeSub' + divVal + w + w).style.display;
			}
			tree2 += "<a href='#'><img id='t"
					+ divVal
					+ w
					+ w
					+ "_tree' src='images/cross_plus.gif' align='absmiddle' border='0' onClick='expandNode("
					+ divVal + w + w + ",1)' ></a>";
			// cjj, only admin users to edit or delete connection
			if (!adminCredentials) {
				// tree2 += "<img id='t" + divVal + w + w + "_folder'
				// src='images/foldericon.gif' align='absmiddle'
				// border='0'>&nbsp;&nbsp;<img src='images/msg_menu.gif'
				// height='12' width='13' id='img"+divVal+w+"'
				// onMouseOut=hidePopupMenu('tree')
				// onmousedown=parent.frame2.hidePopupMenu('');parent.frame2.frame3.hidePopupMenu('');onMouseDownHandler(event,'img"+divVal+w+"','Client','"+w+"')
				// />";
				tree2 += "<img id='t"
						+ divVal
						+ w
						+ w
						+ "_folder' src='images/foldericon.gif' align='absmiddle' border='0'>"; // no
																								// popup
																								// menu
			} else {
				tree2 += "<img id='t"
						+ divVal
						+ w
						+ w
						+ "_folder' src='images/foldericon.gif' align='absmiddle' border='0'>&nbsp;&nbsp;<img src='images/msg_menu.gif' height='12' width='13' id='img"
						+ divVal
						+ w
						+ "' onMouseOut=hidePopupMenu('tree') onmousedown=parent.frame2.hidePopupMenu('');parent.frame2.frame3.hidePopupMenu('');onMouseDownHandler(event,'img"
						+ divVal + w + "','Client','" + w
						+ "') onClick=menuUpdateDel('img" + divVal + w
						+ "','Client','" + w + "') />";
			}
			// cjj end
			tree2 += "<font align='absmiddle'>&nbsp;&nbsp;<a href='#' onClick=showClientLoginDialog("
					+ w + ") >" + xml_client[w] + "</a></font>";

			tree2 += "<br/><div id='treeSub" + divVal + w + w
					+ "' style=display:none>";

			xml_connection[0] = xml_mgr[w];
			xml_connection[1] = xml_host[w];
			xml_connection[2] = xml_channel[w];
			xml_connection[3] = xml_port[w];
			tree2 += expandTree("MQSeries", xml_connection, divVal + w + w, 3);

			tree2 += "</div></div>";

		}
	tree2 += "<div id='treeSub" + divVal + w + "' >";
	
	if (env_type == "all" || env_type == "")
		tree2 += "<img src='images/line.gif' align='absmiddle' border='0'>";
	else
		tree2 += "<img src='images/white.gif' align='absmiddle' border='0'>";
	
	tree2 += "<img src='images/white.gif' align='absmiddle' border='0'>";
	tree2 += "<img src='images/corner.gif' align='absmiddle' border='0'>";
	tree2 += "<a href='#' onClick='displayAddNewClient()' ><font>Add New Client</font></a><br/><div id='treeSub"
			+ divVal + w + "' style='display:none'>";

	tree2 += "</div></div>";

	if (parent.clientIndex != 1)
		expandNode('101', 2);
	
	document.getElementById('treeSub' + divVal).innerHTML = tree2;

	for ( var q = 0; q < xml_client.length; q++) {
		if (document.getElementById('treeSub' + divVal + q) != null) {
			var temp = document.getElementById('treeSub' + divVal + q)
					.getAttribute('nameC');
			if (clientStatus[temp] == "block" || !adminCredentials)
				expandNode(divVal + q + q, 1, "ClientConnnectionSubTree");
		}
	}
}


function clientConnectionByQMName(divVal) {
	var clientStatus = new Array();
	var tree2 = "";

	if (document.getElementById('treeSub101') != null)
        //TODO sorted display
		//xml_sort_list
		//for (w = 0; w < xml_client.length; w++) {
		//IF08

		 
		
		for (iPointer = 0; iPointer < xml_sort_list.length; iPointer++) {
			var w = xml_sort_list[iPointer][1] ;
			 
			tree2 += "<div id='treeSub" + divVal + w + "' nameC='"
					+ xml_client[w] + "' >";
			if (env_type == "all" || env_type == "")
				tree2 += "<img src='images/line.gif' align='absmiddle' border='0'>";
			else
				tree2 += "<img src='images/white.gif' align='absmiddle' border='0'>";
			tree2 += "<img src='images/white.gif' align='absmiddle' border='0'>";

			if (document.getElementById('treeSub' + divVal + w + w) != null) {
				clientStatus[document.getElementById('treeSub' + divVal + w)
						.getAttribute('nameC')] = document
						.getElementById('treeSub' + divVal + w + w).style.display;
			}
			tree2 += "<a href='#'><img id='t"
					+ divVal
					+ w
					+ w
					+ "_tree' src='images/cross_plus.gif' align='absmiddle' border='0' onClick='expandNode("
					+ divVal + w + w + ",1)' ></a>";
			// cjj, only admin users to edit or delete connection
			if (!adminCredentials) {
			 
				tree2 += "<img id='t"
						+ divVal
						+ w
						+ w
						+ "_folder' src='images/foldericon.gif' align='absmiddle' border='0'>"; // no
																								// popup
																								// menu
			} else {
				tree2 += "<img id='t"
						+ divVal
						+ w
						+ w
						+ "_folder' src='images/foldericon.gif' align='absmiddle' border='0'>&nbsp;&nbsp;<img src='images/msg_menu.gif' height='12' width='13' id='img"
						+ divVal
						+ w
						+ "' onMouseOut=hidePopupMenu('tree') onmousedown=parent.frame2.hidePopupMenu('');parent.frame2.frame3.hidePopupMenu('');onMouseDownHandler(event,'img"
						+ divVal + w + "','Client','" + w
						+ "') onClick=menuUpdateDel('img" + divVal + w
						+ "','Client','" + w + "') />";
			}
			// cjj end
			tree2 += "<font align='absmiddle'>&nbsp;&nbsp;<a href='#' onClick=showClientLoginDialog("
					+ w + ") >" + xml_sort_list[iPointer][0] + "</a></font>";

			tree2 += "<br/><div id='treeSub" + divVal + w + w
					+ "' style=display:none>";

			xml_connection[0] = xml_mgr[w];
			xml_connection[1] = xml_host[w];
			xml_connection[2] = xml_channel[w];
			xml_connection[3] = xml_port[w];
			tree2 += expandTree("MQSeries", xml_connection, divVal + w + w, 3);

			tree2 += "</div></div>";
		 

		}
	tree2 += "<div id='treeSub" + divVal + w + "' >";
	
	if (env_type == "all" || env_type == "")
		tree2 += "<img src='images/line.gif' align='absmiddle' border='0'>";
	else
		tree2 += "<img src='images/white.gif' align='absmiddle' border='0'>";
	
	
	
	tree2 += "<img src='images/white.gif' align='absmiddle' border='0'>";
	tree2 += "<img src='images/corner.gif' align='absmiddle' border='0'>";
	tree2 += "<a href='#' onClick='displayAddNewClient()' ><font>Add New Client</font></a><br/><div id='treeSub"
			+ divVal + w + "' style='display:none'>";

	tree2 += "</div></div>";

	if (parent.clientIndex != 1)
		expandNode('101', 2);
	
	document.getElementById('treeSub' + divVal).innerHTML = tree2;

	for ( var q = 0; q < xml_client.length; q++) {
		if (document.getElementById('treeSub' + divVal + q) != null) {
			var temp = document.getElementById('treeSub' + divVal + q)
					.getAttribute('nameC');
			if (clientStatus[temp] == "block" || !adminCredentials)
				expandNode(divVal + q + q, 1, "ClientConnnectionSubTree");
		}
	}
}



function displayAddNewClient() {
	if (switchDefaultModuleQueue) {
		displayDialog(parent.CLIENTMODAL2, 'Client');
	} else {
		displayDialog(parent.CLIENTMODAL, 'Client');
	}
}

var tempScroll;
/*******************************************************************************
 * The function expandNode is called when a '+' or '-' image is clicked in front
 * of a menu item. This function hides the tree for a menu if the tree is
 * visible and makes the tree visible if the tree for that menu is not currently
 * displayed or is hidden. The arguments it takes are: nodeDiv : is the id of
 * the div tag where the tree for that menu is to be displayed or is already
 * displaying. index : is 0 if the clicking of the '-' image has to hide the
 * tree as well as tree of the submenus for that menu. It is 2 if then that menu
 * item is the last one in the menu so the images to be used for its display are
 * corner images.
 ******************************************************************************/
function expandNode(nodeDiv, index, flag) {
	tempScroll = document.body.scrollTop;
	// cjj, make the operation for the subtree button of the "Client
	// Connections" tree node disable if the user logged on has no sufficient
	// credentials
	if (flag != undefined && flag == "ClientConnnectionSubTree"
			&& !adminCredentials) {
		document.getElementById("t" + nodeDiv + "_tree").src = "images/cross.gif";
		document.getElementById("t" + nodeDiv + "_tree").disabled = true;
		document.getElementById("t" + nodeDiv + "_tree").style.cursor = 'default';
		return;
	}
	// end cjj
	// open tree Node
	if (document.getElementById('treeSub' + nodeDiv).style.display == "none") {
		document.getElementById('treeSub' + nodeDiv).style.display = "block";
		if (index == 2
				|| (!(env_type == "all" || env_type == "") && index == 0))
			document.getElementById("t" + nodeDiv + "_tree").src = "images/corner_minus.gif";
		else
			document.getElementById("t" + nodeDiv + "_tree").src = 'images/cross_minus.gif';
		document.getElementById("t" + nodeDiv + "_folder").src = "images/openfolderque.gif";

	}
	// close tree Node
	else {
		document.getElementById('treeSub' + nodeDiv).style.display = "none";
		document.getElementById("t" + nodeDiv + "_folder").src = "images/foldericon.gif";
		if (index == 2
				|| (!(env_type == "all" || env_type == "") && index == 0))
			document.getElementById("t" + nodeDiv + "_tree").src = "images/corner_plus.gif";
		else
			document.getElementById("t" + nodeDiv + "_tree").src = "images/cross_plus.gif";
		if (index == 0) {
			for (z = 0; z <= 1; z++) {
				document.getElementById('treeSub' + nodeDiv + z).style.display = "none";
				if (z == 1)
					document.getElementById('t' + nodeDiv + z + '_tree').src = "images/corner_plus.gif";
				else
					document.getElementById('t' + nodeDiv + z + '_tree').src = "images/cross_plus.gif";
				document.getElementById("t" + nodeDiv + z + "_folder").src = "images/foldericon.gif";
			}
		}

	}

	setTimeout("fixTreeScroll()", 1);

}

function fixTreeScroll() {
	parent.frame1.document.body.scrollTop = tempScroll;
}

/*******************************************************************************
 * The function expandTree is called wheever a '+' image is clicked in the menu
 * in oredr to display the tree for that menu.The arguments it takes are: type :
 * is 'JMS' or 'Clients'. xml_array : is the array of items to be display as
 * tree for that menu. divValue : is the id of the div tag when the tree is to
 * be displayed. index : depending on the value of the index the space and line
 * image are plced in order to display the menu tree correctly.
 ******************************************************************************/
function expandTree(type, xml_array, divValue, index) {
	var tree1 = "";
	var len;
	var grade = divValue.length;
	if (index == 2)
		len = xml_array.length;
	else
		len = xml_array.length - 1;

	if (xml_array != null) {
		for (i = 0; i < len; i++) {
			if (xml_array[i] != "") {
				tree1 += "<div id='treeSub" + divValue + i + "'>";
				if (index == 2) {
					tree1 += "<img src='images/white.gif' align='absmiddle' border='0'>";
					grade -= 1;
				}
				if (index == 3) {
					if (env_type == "all" || env_type == "")
						tree1 += "<img src='images/line.gif' align='absmiddle' border='0'>";
					else
						tree1 += "<img src='images/white.gif' align='absmiddle' border='0'>";

					tree1 += "<img src='images/white.gif' align='absmiddle' border='0'>";
					tree1 += "<img src='images/line.gif' align='absmiddle' border='0'>";
				} else {
					if (env_type == "all" || env_type == "")
						tree1 += "<img src='images/line.gif' align='absmiddle' border='0'>";
					else
						tree1 += "<img src='images/white.gif' align='absmiddle' border='0'>";
					for (a = 1; a < grade - 1; a++)
						tree1 += "<img src='images/line.gif' align='absmiddle' border='0'>";
				}
				tree1 += "<img src='images/cross.gif' align='absmiddle' border='0'>";
				if (index == 3)
					tree1 += "<font>" + xml_array[i] + "</font><br/></div>";
				else
					tree1 += "<font><a href = '#' onClick=parent.setPointer('"
							+ xml_array[i] + "','" + type + "') >"
							+ xml_array[i] + "</a></font><br/></div>";
			}

		}
		tree1 += "<div id='treeSub" + divValue + i + "' >";

		if (index == 2) {
			tree1 += "<img src='images/white.gif' align='absmiddle' border='0'>";
		}

		if (index == 3) {
			if (env_type == "all" || env_type == "")
				tree1 += "<img src='images/line.gif' align='absmiddle' border='0'>";
			else
				tree1 += "<img src='images/white.gif' align='absmiddle' border='0'>";
			tree1 += "<img src='images/white.gif' align='absmiddle' border='0'>";
			tree1 += "<img src='images/line.gif' align='absmiddle' border='0'>";
		} else {
			if (env_type == "all" || env_type == "")
				tree1 += "<img src='images/line.gif' align='absmiddle' border='0'>";
			else
				tree1 += "<img src='images/white.gif' align='absmiddle' border='0'>";
			for (a = 1; a < grade - 1; a++)
				tree1 += "<img src='images/line.gif' align='absmiddle' border='0'>";
		}

		tree1 += "<img src='images/corner.gif' align='absmiddle' border='0'>";
		if (index == 2)
			tree1 += "<a href='#' onClick='parent.M_displayAddNewJMS()' ><font>&nbsp;&nbsp;Add New JMS</font></a><br/></div>";
		else {
			if (index == 3)
				tree1 += "<font>" + xml_array[i] + "</font><br/></div>";
			else
				tree1 += "<font><a href = '#' onClick=parent.setPointer('"
						+ xml_array[i] + "','" + type + "') >" + xml_array[i]
						+ "</a></font><br/></div>";
		}

	}
	return tree1;
}

function expandTree2(type, xml_array, divValue, index) {
	var tree1 = "";
	var len;
	var grade = divValue.length;
	if (index == 2)
		len = xml_array.length;
	else
		len = xml_array.length - 1;

	if (xml_array != null) {
		for (i = 0; i < len; i++) {
			if (xml_array[i] != "") {
				tree1 += "<div id='treeSub" + divValue + i + "'>";
				if (index == 2) {
					tree1 += "<img src='images/white.gif' align='absmiddle' border='0'>";
					grade -= 1;
				}
				if (index == 3) {
					if (env_type == "all" || env_type == "")
						tree1 += "<img src='images/line.gif' align='absmiddle' border='0'>";
					else
						tree1 += "<img src='images/white.gif' align='absmiddle' border='0'>";

					tree1 += "<img src='images/white.gif' align='absmiddle' border='0'>";
					tree1 += "<img src='images/line.gif' align='absmiddle' border='0'>";
				} else {
					if (env_type == "all" || env_type == "")
						tree1 += "<img src='images/line.gif' align='absmiddle' border='0'>";
					else
						tree1 += "<img src='images/white.gif' align='absmiddle' border='0'>";
					for (a = 1; a < grade - 1; a++)
						tree1 += "<img src='images/line.gif' align='absmiddle' border='0'>";
				}
				tree1 += "<img src='images/cross.gif' align='absmiddle' border='0'>";
				if (index == 3)
					tree1 += "<font>" + xml_array[i] + "</font><br/></div>";
				else
					tree1 += "<font><a href = '#' onClick=parent.setPointer('"
							+ xml_array[i] + "','" + type + "') >"
							+ xml_array[i] + "</a></font><br/></div>";
			}

		}
		tree1 += "<div id='treeSub" + divValue + i + "' >";

		if (index == 2) {
			tree1 += "<img src='images/white.gif' align='absmiddle' border='0'>";
		}

		if (index == 3) {
			if (env_type == "all" || env_type == "")
				tree1 += "<img src='images/line.gif' align='absmiddle' border='0'>";
			else
				tree1 += "<img src='images/white.gif' align='absmiddle' border='0'>";
			tree1 += "<img src='images/white.gif' align='absmiddle' border='0'>";
			tree1 += "<img src='images/line.gif' align='absmiddle' border='0'>";
		} else {
			if (env_type == "all" || env_type == "")
				tree1 += "<img src='images/line.gif' align='absmiddle' border='0'>";
			else
				tree1 += "<img src='images/white.gif' align='absmiddle' border='0'>";
			for (a = 1; a < grade - 1; a++)
				tree1 += "<img src='images/line.gif' align='absmiddle' border='0'>";
		}

		tree1 += "<img src='images/corner.gif' align='absmiddle' border='0'>";
		if (index == 2)
			tree1 += "<a href='#' onClick='parent.M_displayAddNewJMS()' ><font>&nbsp;&nbsp;Add New JMS</font></a><br/></div>";
		else {
			if (index == 3)
				tree1 += "<font>" + xml_array[i] + "</font><br/></div>";
			else
				tree1 += "<font><a href = '#' onClick=parent.setPointer('"
						+ xml_array[i] + "','" + type + "') >" + xml_array[i]
						+ "</a></font><br/></div>";
		}

	}
	return tree1;
}




function expandMQTree() {
	var xml_mq = parent.M_listResources();
	if (xml_mq) {
		if (getMQDetails(xml_mq)) {
			var html = "";
			html += expandTree("MQSeries", array_mq, '100', 1);
			document.getElementById('treeSub100').innerHTML = html;
		}
		expandNode("10", 0);
	}
	resetCursor_Tree();
}

/*******************************************************************************
 * The function generateTree is called by the Manager when leftColumn htm file
 * is displayed on the left frame with 'true' as the value of 'load'
 * :kxylCol.htm?load=true;.The arguments it takes are: xml_mq : is 'a XML DOM
 * object for the xml that has values of all the Local Queue Managers for MQ
 * Series.
 ******************************************************************************/
var env_type = "";
function generateTree(envType) {
	if (envType != null && envType != "")
		env_type = envType.toLowerCase();
	var tree = '';
	tree += '<font><b>Console Root</b></font>';

	if (env_type == "all" || env_type == "mqseries" || env_type == "") {
		tree += '<div id="treeSub1"><a href="#">';
		if (env_type == "all" || env_type == "")
			tree += '<img id="t10_tree" src="images/cross_plus.gif" align="absmiddle" border="0" onClick="setCursor_Tree(1)" ></a>';
		else
			tree += '<img id="t10_tree" src="images/corner_plus.gif" align="absmiddle" border="0" onClick="setCursor_Tree(1)" ></a>';

		tree += '<img id="t10_folder" src="images/foldericon.gif" align="absmiddle" border="0">';
		tree += '<font><b>&nbsp;&nbsp;WebSphere MQ</b></font><div id="treeSub10" style="display:none">';

		tree += "<div id='treeSub10'>";
		if (env_type == "all" || env_type == "")
			tree += "<img src='images/line.gif' align='absmiddle' border='0'>";
		else
			tree += "<img src='images/white.gif' align='absmiddle' border='0'>";
		tree += "<a href='#'><img id='t100_tree' src='images/cross_plus.gif' align='absmiddle' border='0' onClick=setCursor_Tree(2); ></a>";
		tree += "<img id='t100_folder' src='images/foldericon.gif' align='absmiddle' border='0'>";
		tree += "<font>&nbsp;&nbsp;Local Queue Managers</font><br/><div id='treeSub100' style='display:none'>";

		tree += "</div>";
		tree += "</div>";

		tree += "<div id='treeSub11'>";
		if (env_type == "all" || env_type == "")
			tree += "<img src='images/line.gif' align='absmiddle' border='0'>";
		else
			tree += "<img src='images/white.gif' align='absmiddle' border='0'>";

		tree += "<a href='#'><img id='t101_tree' src='images/corner_plus.gif' align='absmiddle' border='0' onClick='setCursor_Tree(31)' ></a>";
		tree += '<img id="t101_folder" src="images/foldericon.gif" align="absmiddle" border="0">';
		// IF08
		tree += "<font id='fontccsort' style='display:none'>&nbsp;&nbsp;</font>"
		tree += "<img id='imgccsort' width='13' height='12' onmouseout='hidePopupMenu(\"tree2\")' onmousedown='parent.frame2.hidePopupMenu(\"\");parent.frame2.frame3.hidePopupMenu(\"\");onMouseDownHandler2(event,\"imgccsort\",\"Client\",\"0\")'  onclick='menuUpdateDel2(\"imgccsort\",\"Client\",\"0\")' align='absmiddle' src='images/msg_menu.gif' style='display:none'/>";

		tree += "<font>&nbsp;&nbsp;Client Connections</font><br/><div id='treeSub101' style='display:none'>";

		tree += "</div>";
		tree += "</div>";

		tree += "</div>";
		tree += "</div>";
	}
	if (env_type == "all" || env_type == "jms" || env_type == "") {
		tree += '<div id="treeSub2"><a href="#"><img id="t20_tree" src="images/corner_plus.gif" align="absmiddle" border="0" onClick="setCursor_Tree(4)" ></a>';
		tree += '<img id="t20_folder" src="images/foldericon.gif" align="absmiddle" border="0">';
		tree += '<font><b>&nbsp;&nbsp;JMS</b></font><div id="treeSub20" style="display:none" >';

		tree += "</div></div>";
	}
	document.getElementById('treeSub0').innerHTML = tree;
}

function checkClientConnection() {
	if (document.getElementById('treeSub101').style.display == "none")
		parent.M_clientConnection();
	else
		expandNode('101', 2);

	resetCursor_Tree();
}
// IF08
function checkClientConnection2() {
	if (document.getElementById('treeSub101').style.display == "none") {
		document.getElementById('fontccsort').style.display = "";
		document.getElementById('imgccsort').style.display = "";
		parent.M_clientConnection();
	} else {
		document.getElementById('fontccsort').style.display = "none";
		document.getElementById('imgccsort').style.display = "none";
		expandNode('101', 2);
	}
	resetCursor_Tree();
}

function checkJMSConnection() {
	if (document.getElementById('treeSub20').style.display == "none")
		parent.M_displayJMS(0);
	else
		expandNode('20', 2);
	resetCursor_Tree();
}

function setCursor_Tree(flag) {
	// if (parent.parent.frame1.document.all)
	// for (var i=0;i < parent.parent.frame1.document.all.length; i++)
	// parent.parent.frame1.document.all(i).style.cursor = 'wait';
	// if(parent.parent.frame2.frame3.document.all)
	// {
	// for (var i=0;i < parent.parent.frame2.frame3.document.all.length; i++)
	// parent.parent.frame2.frame3.document.all(i).style.cursor = 'wait';
	// }

	switch (flag) {
	case 1:
		setTimeout('expandMQTree()', 1);
		break;
	case 2:
		setTimeout('expandMQ()', 1);
		break;
	case 3:
		setTimeout('checkClientConnection()', 1);
		break;
	case 31:
		setTimeout('checkClientConnection2()', 1);
		break;
	case 4:
		setTimeout('checkJMSConnection()', 1);
		break;
	}
}

function resetCursor_Tree() {
	// if (parent.parent.frame1.document.all)
	// for (var i=0;i < parent.parent.frame1.document.all.length; i++)
	// parent.parent.frame1.document.all(i).style.cursor = 'auto';
	//	if(parent.parent.frame2.frame3.document.all)
	//	{
	//		for (var i=0;i < parent.parent.frame2.frame3.document.all.length; i++)
	//			parent.parent.frame2.frame3.document.all(i).style.cursor = 'auto';
	//	}
}

function expandMQ() {
	expandNode(100, 1);
	resetCursor_Tree();
}

//IF08
function queueManagerSortAction(item) {
	switch (item) {
	case "HostName":
		if (!queueManagerSortByHost) {
			queueManagerSortByHost = true;
			clientConnection('101');	
			expandNode('101',2);
		}
		break;
	case "QueueManagerName":
		if (queueManagerSortByHost) {
			queueManagerSortByHost = false;			
			clientConnection('101');
			expandNode('101',2);
		}
		break;
	default:
		M_alert("Not yet implemented.");
		break;
	}

}

function clientConnection(divVal){
	if (queueManagerSortByHost) {
		clientConnectionByHostName(divVal);	
	}else{
		clientConnectionByQMName(divVal);		
	}	
	
}
